#pragma once
#include "afx.h"

// CMGC4IZ R}h ^[Qbg
//
//	mgc4iz.dll  Header Ver4.1600a
//
class CMGC4IZ : public CObject
{
public:

	//
	//// common
	//
	static const INT success		= 0;
	static const INT failure 		= -1;
 	static const INT mizTrue 		= TRUE;
 	static const INT mizFalse		= FALSE;
 	static const INT yes			= TRUE;
 	static const INT no				= FALSE;
 	static const INT null			= NULL;
 	static const INT maxPath		= MAX_PATH;
 	static const INT lengthName		= 512;
 	static const INT lengthValue	= 65536;
 	static const INT lengthRawValue = 65536;
	
	// Error
 	static const INT mizFailure			= -1;
 	static const INT errFile			= -101;
 	static const INT errUnknownFile		= -102;
 	static const INT errNONExif			= -103;
 	static const INT errMemory			= -104;
 	static const INT errNoResource		= -106;
 	static const INT errResource		= -107;
 	static const INT errThumbnailImage	= -108;
 	static const INT errThumbnailMemory = -300;
 	static const INT errFileCopy		= -400;	// 摜t@C̃Rs[sS
 	static const INT errFileWrite		= -401;	// HTMLt@C̏ݕsS
 	static const INT errFormePointer	= -402;	// form ̏s
 	static const INT errFormSize		= -403;	// form ̑TCYs
 	static const INT errFormNotReady	= -404;	// form resourse ̎w肪Ȃ
 	static const INT errFormQueue		= -405;	// ҂s̃TCYs
 	static const INT errFormValiables	= -406;	// form ̕ϐ̐s

	//
	//// mizInitialize
	//
	// \
	typedef struct
	{
		LPWSTR lpszResourceFile;	// TeCgckk
	} INI_DATA, *LPINI_DATA;

	//
	////	Begin
	//
 	static const INT command			= 0x000000ff;
 	static const INT options			= 0xffffff00;
 	static const INT cmdReset			= 0x00000000;
 	static const INT cmdRead			= 0x00000001;
 	static const INT cmdBegin			= 0x00000002;
 	static const INT cmdGetField		= 0x00000003;
 	static const INT cmdGetThumbnail	= 0x00000004;
 	static const INT cmdGetFileCrc		= 0x00000005;
 	static const INT cmdLoadForm		= 0x00000006;
 	static const INT cmdSaveFile		= 0x00000007;

 	static const INT optNoReset				= 0x00000000;	// Option for cmdReset
 	static const INT optResetThumbnail		= 0x00000100;	// Option for cmdReset
 	static const INT optResetField			= 0x00000200;	// Option for cmdReset
 	static const INT optUnit				= 0x00000000;	// Option for cmdRead
 	static const INT optIncludeThumbnail	= 0x00000100;	// Option for cmdRead
 	static const INT optNonUnit				= 0x00000200;	// Option for cmdRead
 	static const INT optRise				= 0x00000000;	// Option for cmdBegin
 	static const INT optDown				= 0x00000100;	// Option for cmdBegin
 	static const INT optGetStrings			= 0x00000000;	// Option for GetField 
 	static const INT optGetData				= 0x00000100;	// Option for GetField 
 	static const INT optCSV					= 0x00000000;	// Option for cmdSAVE_FILE
 	static const INT optHtmlForm0			= 0x00000100;	// Option for cmdSAVE_FILE
 	static const INT optHtmlForm1			= 0x00000200;	// Option for cmdSAVE_FILE
 	static const INT optFileType			= 0x0000ff00;	// Option for cmdSAVE_FILE
	static const INT optCode				= 0x0fff0000;	// Option for cmdSAVE_FILE
	static const INT optCodeSJIS			= 0x00000000;	// Option for cmdSAVE_FILE
	static const INT optCodeUTF8			= 0x00010000;	// Option for cmdSAVE_FILE
	static const INT optCodeUTF16BE			= 0x00020000;	// Option for cmdSAVE_FILE
	static const INT optCodeUTF16LE			= 0x00030000;	// Option for cmdSAVE_FILE


 	static const INT resetALL		= cmdReset | optResetField | optResetThumbnail;
 	static const INT resetField		= cmdReset | optResetField;
 	static const INT resetThumbnail	= cmdReset | optResetThumbnail;
 	static const INT read			= cmdRead  | optNonUnit;
 	static const INT readPlusOne	= cmdRead  | optIncludeThumbnail | optNonUnit;
 	static const INT beginRise		= cmdBegin | optRise;
 	static const INT beginDown		= cmdBegin | optDown;
 	static const INT getStrings		= cmdGetField;
 	static const INT getData		= cmdGetField | optGetData;
 	static const INT getThumbnail	= cmdGetThumbnail;
 	static const INT getFieldCRC	= cmdGetFileCrc;


	// IFD ̎
 	static const INT kindIfdTiff				= 0x0000;
 	static const INT kindIfdExif				= 0x8769;
 	static const INT kindIfdGps					= 0x8825;
 	static const INT kindIfdInteroperability	= 0xA005;
 	static const INT kindIfdThumbnail			= 0x0001;
	// IFD f[^`
 	static const INT tifLittleEndian	= (USHORT)0x4949;	// GfBA`
 	static const INT tifBigEndian		= (USHORT)0x4D4D;	// rbOGfBA`
	//// IFD Type
 	static const INT ifdTypeByte		= (USHORT)1;	// 8 rbgB
 	static const INT ifdTypeAscii		= (USHORT)2;	// 7 sbgASCII R[h[߂8 rbgoCgB
 	static const INT ifdTypeShort		= (USHORT)3;	// 16 rbgi2 oCgjB
 	static const INT ifdTypeLong		= (USHORT)4; 	// 32 rbgi4 oCgjB
 	static const INT ifdTypeRational	= (USHORT)5; 	// _u LONGBŏLONG ͕qA2 ڂLONG ͕\B
 	static const INT ifdTypeUndefined	= (USHORT)7; 	// tB[h̒`ɂAǂȒlƂĂǂ8 rbgoCgB
 	static const INT ifdTypeSLong		= (USHORT)9; 	// 32 rbgi4 oCgjti2 ̕␔\jB
 	static const INT ifdTypeSrational	= (USHORT)10; 	// _u SLONGBŏSLONG ͕qA2 ڂSLONG ͕\B

	// html resource ID
 	static const INT idrHtmlForm0	= 64000;	// idrHtmlForm0 for openoffice ;	
 	static const INT idrHtmlForm1	= 64001;	// idrHtmlForm1 for microsoft office;	
	// html form
 	static const INT formField			= 0;
 	static const INT formheader			= 1;
 	static const INT formImage			= 2;
 	static const INT formFieldsHeader	= 3;
 	static const INT formOther			= 4;
 	static const INT formFreeOne		= 5;
 	static const INT formFooter			= 6;
 	static const INT formMetadata0s		= 7;
 	static const INT formMetadata1s		= 8;	// ms form
 	static const INT formMetadata2s		= 9;	// ms form
 	static const INT formStructure0		= 10;
 	static const INT formStructure1		= formStructure0;
 	static const INT formMax			= 11;
 	static const INT formCount0			= 9;
 	static const INT formCount1			= formMax;

	// size of html form ////////////////////////////////////////////////////////////////////////////// 
	// If FORM of a resource is changed, it is necessary to change the form size. 
	// Please change a required line. 	-->
 	static const INT formLengthDontUse			= 0;
 	static const INT formLengthField			= 285;
 	static const INT formLengthHeader			= 226;
 	static const INT formLengthFieldsHeader		= 347;
 	static const INT formLengthImage			= 204;
 	static const INT formLengthOther			= 71;
 	static const INT formLengthFreeOne			= 3;
 	static const INT formLengthFooter			= 91;
 	static const INT formLengthMetadata0s		= 33;
 	static const INT formLengthMetadata1s		= 19;
 	static const INT formLengthMetadata2s		= 30;
 	static const INT formLengthStructure0		= 505;
 	static const INT formLengthStructure1		= 874;
 	static const INT form0Length				= 1765;
 	static const INT form1Length				= 2183;

 	static const INT formEnuLengthSrtructure0	= 494;
 	static const INT formEnuLengthSrtructure1	= 862;
 	static const INT form0EnuLength				= 1754;
 	static const INT form1EnuLength				= 2171;
	// <-- 

	// Elements for Form
 	static const INT elementDontOutput		= 0;
 	static const INT elementHeader			= 1;
 	static const INT elementImage			= 2;
 	static const INT elementFieldHeader		= 3;
 	static const INT elementFields			= 4;
 	static const INT elementOther0			= 5;
 	static const INT elementOther1			= 6;
 	static const INT elementOther2			= 7;
 	static const INT elementOther3			= 8;
 	static const INT elementOther4			= 9;
 	static const INT elementOther5			= 10;
 	static const INT elementOther6			= 11;
 	static const INT elementOther7			= 12;
 	static const INT elementOther8			= 13;
 	static const INT elementOther9			= 14;
 	static const INT elementFreeOne0		= 15;
 	static const INT elementFreeOne1		= 16;
 	static const INT elementFreeOne2		= 17;
 	static const INT elementFreeOne3		= 18;
 	static const INT elementFreeOne4		= 19;
 	static const INT elementFreeOne5		= 20;
 	static const INT elementFreeOne6		= 21;
 	static const INT elementFreeOne7		= 22;
 	static const INT elementFreeOne8		= 23;
 	static const INT elementFreeOne9		= 24;
 	static const INT elementFooter			= 25;
 	static const INT elementsMax			= 25;
 	static const INT elementsOtherMax		= 10;
 	static const INT elementsFreeOneMax		= 10;
	// structure
 	static const INT structureSizeA	= 512;
	// structure
 	static const INT headerSizeA		= 256;
 	static const INT headerSizeB		= 128;
	// kind of metadata
 	static const INT metadataMax		= 24;
 	static const INT metadataSizeA		= 512;
 	static const INT metadataSizeB		= 128;
	// field
 	static const INT fieldSizeA	= 128;
	// other
 	static const INT otherSizeA	= 512;
	// free one
 	static const INT freeOneSizeA	= 512;
	// footer
 	static const INT footerSizeA	= 256;
	// csv
 	static const INT csvSizeA		= 512;
 	static const INT csvSizeB		= 128;
 	static const INT csvMaxCount	= 16;


	//
	//// ߂l
	//
	static const INT lastField = 100;

	//
	//// \
	//
	typedef struct
	{
		USHORT	nEndian;
		USHORT	nTag;
		USHORT	nType;
		LONG	nCount;
		BYTE	szValues[lengthRawValue];
	} FIELD_DATA, *LPFIELD_DATA;

	typedef struct
	{
		DWORD	dwKindIFD;
		USHORT	nTag;
		LPSTR	lpszName;
		LPSTR	lpszValues;
	} FIELD_STRINGS, *LPFIELD_STRINGS;

	typedef struct
	{
		INT	nName;		// for FIELD_STRINGS
		INT	nValue;		// for FIELD_STRINGS
		INT	nRawValues;	// for FIELD_DATA
	} TEXT_SIZE, *LPTEXT_SIZE;

	// thambnail
	typedef struct
	{
		INT		nCompression;
		INT		nSize;
		BYTE*	lpszImage;
	} THUMBNAIL_IMAGE, *LPTHUMBNAIL_IMAGE;

	// Html resource
	typedef struct
	{
		INT	nID;
		INT	nTotalLength;
		INT	nLength[formMax];
	} HTML_RESOURCE, *LPHTML_RESOURCE;

	// method for html
	typedef struct
	{
		// TARGET
		CHAR	szPath[maxPath];		// Html o͐ = %drive%\x1
		CHAR	szFileName[maxPath];	// K .htm t
		INT		nQueue[elementsMax];	// elements ̏o͏
		INT		nQueueCount;				// Queue ̐
		// Srtructure
		CHAR	szTitle[structureSizeA];
		// MetadataS
		INT		nCountForMetadata;
		CHAR	szNameOfMetadata[metadataMax][metadataSizeB];
		CHAR	szContentOfMetadata[metadataMax][metadataSizeA];

		// ȉ elements -->
		// header
		CHAR	szHeaderTitle[headerSizeA];
		CHAR	szDate[headerSizeB];
		// IMAGE
		CHAR	szImagePathAndName[maxPath];	// 摜̏ꏊƃt@C = %drive%\folder\image.jpg
		CHAR	szImageName[maxPath];			// 摜t@C = image.jpg
		INT		nImageWidth;
		INT		nImageHeight;
		// FIELDS header
		CHAR szFieldNames[4][fieldSizeA];
		CHAR szKinds[5][fieldSizeA];
		// Other
		CHAR szOthers[elementsOtherMax][otherSizeA];
		// FreeOne
		CHAR szFreeOnes[elementsFreeOneMax][freeOneSizeA];
		// FOOTER
		CHAR szFooter[footerSizeA];
		// <-- elements
	} METHOD_FOR_FORM0, *LPMETHOD_FOR_FORM0;

	typedef struct
	{
		// TARGET
		CHAR	szPath[maxPath];		// Html o͐ = %drive%\x1
		CHAR	szFileName[maxPath];	// K .htm t
		INT		nQueue[elementsMax];	// elements ̏o͏
		INT		nQueueCount;				// Queue ̐
		// Srtructure
		CHAR	szTitle[structureSizeA];
		// MetadataS
		INT		nCountForMetadata0;
		CHAR	szNameOfMetadata0[metadataMax][metadataSizeB];
		CHAR	szContentOfMetadata0[metadataMax][metadataSizeA];

		// ȉ elements -->
		// header
		CHAR	szHeaderTitle[headerSizeA];
		CHAR	szDate[headerSizeB];
		// IMAGE
		CHAR	szImagePathAndName[maxPath];	// 摜̏ꏊƃt@C = %drive%\folder\image.jpg
		CHAR	szImageName[maxPath];			// 摜t@C = image.jpg
		INT		nImageWidth;
		INT		nImageHeight;
		// FieldS header
		CHAR szFieldNames[4][fieldSizeA];
		CHAR szKinds[5][fieldSizeA];
		// Other
		CHAR szOthers[elementsOtherMax][otherSizeA];
		// FreeOne
		CHAR szFreeOnes[elementsFreeOneMax][freeOneSizeA];
		// FOOTER
		CHAR szFooter[footerSizeA];
		// <-- elements

		// MetadataS1
		INT		nCountForMetadata1;
		CHAR	szNameOfMetadata1[metadataMax][metadataSizeB];
		CHAR	szContentOfMetadata1[metadataMax][metadataSizeA];
		// MetadataS2
		INT		nCountForMetadata2;
		CHAR	szNameOfMetadata2[metadataMax][metadataSizeB];
		CHAR	szTypeOfMetadata2[metadataMax][metadataSizeB];
		CHAR	szContentOfMetadata2[metadataMax][metadataSizeA];
	} METHOD_FOR_FORM1, *LPMETHOD_FOR_FORM1;

	// csv
	typedef struct
	{
		CHAR	szPath[maxPath];		// csv o͐ = %drive%\x1
		CHAR	szFileName[maxPath];		// csv O = jpeg.csv K .csv t
		CHAR	szKinds[5][csvSizeB];
		INT		nCount;
		CHAR	szNames[csvMaxCount][csvSizeA];
		CHAR	szValues[csvMaxCount][csvSizeA];
	} METHOD_FOR_CSV, *LPMETHOD_FOR_CSV;

	//
	//// Tiff IFD TAG
	//
 	static const INT tagImageWidth					= (USHORT)0x100;	// 摜̕ 
 	static const INT tagImageLength					= (USHORT)0x101;	// 摜̍ 
 	static const INT tagBitSperSample				= (USHORT)0x102;	// 摜̃rbg̐[
 	static const INT tagCompression					= (USHORT)0x103;	// k̎
 	static const INT tagPhotoMetricinterpretation	= (USHORT)0x106;	// f\
 	static const INT tagThreshholding				= (USHORT)0x107;	// 臒l
 	static const INT tagCellWidth 			 		= (USHORT)0x108; 	// Z
 	static const INT tagCellLength 				 	= (USHORT)0x109; 	// Z
 	static const INT tagFillorder 			 		= (USHORT)0x10A; 	// tBI[_[
 	static const INT tagDocumentName 			 	= (USHORT)0x10D; 	// ͉摜
 	static const INT tagImageDescriotion			= (USHORT)0x10E;	// 摜^Cg
 	static const INT tagMake 						= (USHORT)0x10F;	// 摜͋@̃[J[
 	static const INT tagModel						= (USHORT)0x110;	// 摜͋@̃f
 	static const INT tagStripOffsets				= (USHORT)0x111;	// 摜f[^̃P[V 
 	static const INT tagOrientation					= (USHORT)0x112;	// 摜
 	static const INT tagSamplesPerPixel				= (USHORT)0x115;	// R|[lg
 	static const INT tagRowSperstrip				= (USHORT)0x116;	// XgbṽC
 	static const INT tagStripByteCounts 			= (USHORT)0x117;	// Xgbṽf[^
 	static const INT tagMinSampleValue 				= (USHORT)0x118; 	// ŏTvOl
 	static const INT tagMaxSampleValue 				= (USHORT)0x119; 	// őTvOl
 	static const INT tagXresolution 				= (USHORT)0x11A;	// 摜̉̕𑜓x
 	static const INT tagYresolution 				= (USHORT)0x11B;	// 摜̍̉𑜓x
 	static const INT tagPlanarConfiguration 		= (USHORT)0x11C;	// 摜f[^̕
 	static const INT tagPageName 			 		= (USHORT)0x11D; 	// ͉摜y[W
 	static const INT tagXposition 			 		= (USHORT)0x11E; 	// 摜̂wʒu
 	static const INT tagYposition 			 		= (USHORT)0x11F; 	// 摜̂xʒu
 	static const INT tagFreeOffsets 			 	= (USHORT)0x120; 	// f[^ʒu
 	static const INT tagFreeByteCounts 				= (USHORT)0x121; 	// f[^
 	static const INT tagGrayResponseUnit 		 	= (USHORT)0x122; 	// OCX|XP
 	static const INT tagGrayResponseCurve 		 	= (USHORT)0x123; 	// OCX|X
 	static const INT tagT4Options 			 		= (USHORT)0x124; 	// T4 IvV
 	static const INT tagT6Options 			 		= (USHORT)0x125; 	// T6 IvV
 	static const INT tagResolutionUnit 				= (USHORT)0x128;	// 摜̕ƍ̉𑜓x̒P
 	static const INT tagPageNumber 			 		= (USHORT)0x129; 	// ͉摜y[W
 	static const INT tagTransferFunction 			= (USHORT)0x12D;	// ĐKJ[u 
 	static const INT tagSoftware 					= (USHORT)0x131;	// gp\tgEFA
 	static const INT tagDateTime 					= (USHORT)0x132;	// t@CύX 
 	static const INT tagArtist 						= (USHORT)0x13B;	// Җ 
 	static const INT tagHostComputer 			 	= (USHORT)0x13C; 	// zXgRs[^[
 	static const INT tagPredictor 			 		= (USHORT)0x13D; 	// Predictor
 	static const INT tagWhitePoint 					= (USHORT)0x13E;	// QƔF_̐FxWl
 	static const INT tagPrimaryChromaticities 		= (USHORT)0x13F;	// F̐FxWl
 	static const INT tagColorMap 			 		= (USHORT)0x140; 	// J[pbg
 	static const INT tagHalfTonehints 			 	= (USHORT)0x141; 	// n[tg[
 	static const INT tagTileWidth 			 		= (USHORT)0x142; 	// ^C
 	static const INT tagTileLength 			 		= (USHORT)0x143; 	// ^C
 	static const INT tagTileOffsets 			 	= (USHORT)0x144; 	// ^CItZbgʒu
 	static const INT tagTileByteCounts 				= (USHORT)0x145; 	// ^CoCg
 	static const INT tagInkSet 						= (USHORT)0x14C; 	// CNZbg
 	static const INT tagInkNames 			 		= (USHORT)0x14D; 	// CN
 	static const INT tagNumberOfInks 			 	= (USHORT)0x14E; 	// CN
 	static const INT tagDotRange 			 		= (USHORT)0x150; 	// hbgW
 	static const INT tagTargetPrinter 			 	= (USHORT)0x151; 	// v^
 	static const INT tagExtraSamples 			 	= (USHORT)0x152; 	// ǉf\
 	static const INT tagSampleFormat 			 	= (USHORT)0x153; 	// W{
 	static const INT tagSMinSampleValue 		 	= (USHORT)0x154; 	// ŏ̕W{l
 	static const INT tagSMAXSampleValue 		 	= (USHORT)0x155; 	// ő̕W{l
 	static const INT tagTransferRange 			 	= (USHORT)0x156; 	// TransferRange
 	static const INT tagJPEGProc 			 		= (USHORT)0x200; 	// JPEGProc
 	static const INT tagJPEGIntercahngeFormat 		= (USHORT)0x201;	// JPEG SOI ւ̃ItZbg
 	static const INT tagJPEGIntercahngeFormatLength = (USHORT)0x202;	// JPEG f[^̃oCg
 	static const INT tagJPEGRestartInterval 		= (USHORT)0x203; 	// JPEGResetartInterval
 	static const INT tagJPEGLosslessPredictors		= (USHORT)0x205; 	// JPEGLosslessPredictors 
 	static const INT tagJPEGPointTransforms			= (USHORT)0x206; 	// JPEGPointTransforms 
 	static const INT tagJPEGQTables					= (USHORT)0x207; 	// JPEGQTables 
 	static const INT tagJPEGDCTables				= (USHORT)0x208; 	// JPEGDCTables
 	static const INT tagJPEGACTables				= (USHORT)0x209; 	// JPEGACTables
 	static const INT tagYcBcRCoefficients			= (USHORT)0x211;	// Fϊ}gNXW
 	static const INT tagYcBcRSUBSAMPLING			= (USHORT)0x212;	// YCC ̉f\iC ̊Ԉj
 	static const INT tagYcBcRPositionING			= (USHORT)0x213;	// YCC ̉f\iY C ̈ʒuj
 	static const INT tagReferenceBlackWhite			= (USHORT)0x214;	// QƍF_lƎQƔF_l
 	static const INT tagCopyright					= (USHORT)0x8298;	// Be쌠/ҏW쌠 
 	static const INT tagExifIFDpointer				= (USHORT)0x8769;	// Exif 
 	static const INT tagGPSINFOpointer				= (USHORT)0x8825;	// GPS 
 	static const INT tagNewSubFileType			 	= (USHORT)0xFE; 	// VTut@C^
 	static const INT tagSubFileType 			 	= (USHORT)0xFF; 	// Tut@C^


	//
	//// Exif IFD TAG
	//
 	static const INT tagExposureTime				= (USHORT)0x829A;	// Io
 	static const INT tagFnumber 					= (USHORT)0x829D;	// F io[ 
 	static const INT tagExposureProgram 	 		= (USHORT)0x8822;	// IovO 
 	static const INT tagSpectralSensitivity 	 	= (USHORT)0x8824;	// XyNgx 
 	static const INT tagISOSpeedRatings 	 		= (USHORT)0x8827;	// ISOXs[h[g 
 	static const INT tagOECF 						= (USHORT)0x8828;	// dϊ֐ 

 	static const INT tagSensitivityType				= (USHORT)0x8830;	// x						+Exif 2.3
 	static const INT tagSTANDERDOutputSensitivity	= (USHORT)0x8831;	// Wo͊x					+Exif 2.3
 	static const INT tagRecommendedExposureIndex	= (USHORT)0x8832;	// Iw					+Exif 2.3
 	static const INT tagISOSpeed					= (USHORT)0x8833;	// ISOXs[h					+Exif 2.3
 	static const INT tagISOSpeedLatitudeYYY			= (USHORT)0x8834;	// ISOXs[h``[h YYY	+Exif 2.3
 	static const INT tagISOSpeedLatitudeZZZ			= (USHORT)0x8835;	// ISOXs[h``[h ZZZ	+Exif 2.3

 	static const INT tagExifVersion 				= (USHORT)0x9000;	// Exif o[W 		
 	static const INT tagDateTimeOriginal  			= (USHORT)0x9003;	// 摜f[^̐ 		
 	static const INT tagDateTimeDigitized  			= (USHORT)0x9004;	// fBW^f[^̍쐬 	
 	static const INT tagComponentsConfiguration 	= (USHORT)0x9101;	// eR|[lg̈Ӗ 		
 	static const INT tagCompressedBitSperPixel 		= (USHORT)0x9102;	// 摜k[h 			
 	static const INT tagShutterSpeedValue 	 		= (USHORT)0x9201;	// Vb^[Xs[h 
 	static const INT tagApertureValue 				= (USHORT)0x9202;	// il 
 	static const INT tagBrightnessValue 	 		= (USHORT)0x9203;	// Pxl 
 	static const INT tagExposureBiasValue 	 		= (USHORT)0x9204;	// I␳l 
 	static const INT tagMaxApertureValue 	 		= (USHORT)0x9205;	// Yŏel 
 	static const INT tagSubjectDistance 	 		= (USHORT)0x9206;	// ʑ̋ 
 	static const INT tagMeteringMode 				= (USHORT)0x9207;	//  
 	static const INT tagLightSource 				= (USHORT)0x9208;	//  
 	static const INT tagFlash 						= (USHORT)0x9209;	// tbV
 	static const INT tagFocalLength 				= (USHORT)0x920A;	// Yœ_ 
 	static const INT tagSubjectarea					= (USHORT)0x9214;	// ʑ̗̈					
 	static const INT tagMakerNote 					= (USHORT)0x927C;	// [J[m[g 				
 	static const INT tagUserComment 				= (USHORT)0x9286;	// [U[Rg 			
 	static const INT tagSubsecTime 					= (USHORT)0x9290;	// DateTime ̃TuZbN 			
 	static const INT tagSubsecTimeOriginal 			= (USHORT)0x9291;	// DateTimeOriginal ̃TuZbN 		
 	static const INT tagSubsecTimeDigitized 		= (USHORT)0x9292;	// DateTimeDigitized ̃TuZbN 		
 	static const INT tagFlashpixVersion 			= (USHORT)0xA000;	// ΉtbVsbNXo[W 	
 	static const INT tagColorSpace 					= (USHORT)0xA001;	// Fԏ 				
 	static const INT tagPixelXdimension 			= (USHORT)0xA002;	// 摜 				
 	static const INT tagPixelYdimension 			= (USHORT)0xA003;	// 摜 				
 	static const INT tagRelatedSoundFile 			= (USHORT)0xA004;	// ֘At@C 			
 	static const INT tagInteroperabilityIFDpointer	= (USHORT)0xA005;	// ݊IFD ւ̃|C^
 	static const INT tagFLASHENERGY 				= (USHORT)0xA20B;	// tbVx 
 	static const INT tagSPATIALFREQUENCYResponse	= (USHORT)0xA20C;	// Ԏg 
 	static const INT tagFOCALPLANEXResolution 		= (USHORT)0xA20E;	// œ_ʂ̉̕𑜓x 
 	static const INT tagFOCALPLANEYResolution 		= (USHORT)0xA20F;	// œ_ʂ̍̉𑜓x 
 	static const INT tagFOCALPLANEResolutionUnit 	= (USHORT)0xA210;	// œ_ʉ𑜓xP 
 	static const INT tagSubjectLOCATION 			= (USHORT)0xA214;	// ʑ̈ʒu 
 	static const INT tagExposureIndex 				= (USHORT)0xA215;	// IoCfbNX 
 	static const INT tagSensingMethod 				= (USHORT)0xA217;	// ZT[ 
 	static const INT tagFileSource 					= (USHORT)0xA300;	// t@C\[X 
 	static const INT tagSCENEType 					= (USHORT)0xA301;	// V[^Cv 
 	static const INT tagCfaPattern 					= (USHORT)0xA302;	// FA p^[ 

 	static const INT tagCustomRendered 				= (USHORT)0xA401;	// JX^C[W			
 	static const INT tagExposureMode 				= (USHORT)0xA402;	// Io[h					
 	static const INT tagWhiteBalance 				= (USHORT)0xA403;	// zCgoX				
 	static const INT tagDigitalZoomRatio 			= (USHORT)0xA404;	// fBW^Y[			
 	static const INT tagFocalLengthIn35mmFilm 		= (USHORT)0xA405;	// RTZYœ_	
 	static const INT tagSceneCaptureType 			= (USHORT)0xA406;	// V[Be^Cv				
 	static const INT tagGainControl 				= (USHORT)0xA407;	// QCRg[			
 	static const INT tagContrast 					= (USHORT)0xA408;	// RgXg					
 	static const INT tagSaturation 					= (USHORT)0xA409;	// ʓx							
 	static const INT tagSharpness 					= (USHORT)0xA40A;	// V[vlX					
 	static const INT tagDEviceSettingDescription 	= (USHORT)0xA40B;	// @ݒ					
 	static const INT tagSubjectDistanceRange 		= (USHORT)0xA40C;	// ʑ͈̂̋				
 	static const INT tagImageUniqueID 				= (USHORT)0xA420;	// Ǝ̉摜 ID				

 	static const INT tagCameraOwnerName				= (USHORT)0xA430;	// JLҖ		+Exif 2.3
 	static const INT tagBodySerialNumber			= (USHORT)0xA431;	// JVAԍ	+Exif 2.3
 	static const INT tagLensSpecification			= (USHORT)0xA432;	// Ydl		+Exif 2.3
 	static const INT tagLensMake					= (USHORT)0xA433;	// Y[J[		+Exif 2.3
 	static const INT tagLensMode					= (USHORT)0xA434;	// Yf		+Exif 2.3
 	static const INT tagLensSerialNumber			= (USHORT)0xA435;	// YVAԍ	+Exif 2.3

 	static const INT tagGamma						= (USHORT)0xA500;	// ĐK}		+Exif 2.3

	//
	//// GPS IFD TAG
	//
 	static const INT tagGpsVersionID 		= (USHORT)0x0; 		// GPS ^Õo[W 	
 	static const INT tagGpsLatitudeREF 		= (USHORT)0x1;  	// k(N)or (S) 		
 	static const INT tagGpsLatitude 		= (USHORT)0x2;  	// ܓxilj 			
 	static const INT tagGpsLongitudeREF 	= (USHORT)0x3;  	// o(E)or o(W) 		
 	static const INT tagGpsLongitude 		= (USHORT)0x4;  	// oxilj 			
 	static const INT tagGpsAltitudeREF 		= (USHORT)0x5;  	// x̒P 				
 	static const INT tagGpsAltitude 		= (USHORT)0x6;  	// xilj 			
 	static const INT tagGpsTimeStamp 		= (USHORT)0x7;   	// GPS ԁiqv̎ԁj
 	static const INT tagGpsSatellites 		= (USHORT)0x8;   	// ʂɎgqM 	
 	static const INT tagGpsStatus 			= (USHORT)0x9;   	// GPS M@̏ 		
 	static const INT tagGpsMeasureMode 		= (USHORT)0xA;   	// GPS ̑ʕ@ 			
 	static const INT tagGpsDOP 				= (USHORT)0xB;   	// ʂ̐M 			
 	static const INT tagGpsSpeedREF 		= (USHORT)0xC;   	// x̒P 				
 	static const INT tagGpsSpeed 			= (USHORT)0xD;   	// xilj 			
 	static const INT tagGpsTrackREF 		= (USHORT)0xE;   	// is̒P 			
 	static const INT tagGpsTrack 			= (USHORT)0xF;   	// isilj 		
 	static const INT tagGpsImgDirectionREF 	= (USHORT)0x10;  	// Be摜̒̕P 
 	static const INT tagGpsImgDirection 	= (USHORT)0x11;  	// Be摜̕ilj
 	static const INT tagGpsMapDatum 		= (USHORT)0x12;  	// ʂɗpn}f[^ 	
 	static const INT tagGpsDestLatitudeREF 	= (USHORT)0x13;  	// ړIn̖k(N)or (S)
 	static const INT tagGpsDestLatitude 	= (USHORT)0x14;  	// ړIn̈ܓxilj 	
 	static const INT tagGpsDestLongitudeREF = (USHORT)0x15;  	// ړIn̓o(E)or o(W)
 	static const INT tagGpsDestLongitude 	= (USHORT)0x16;  	// ړIňoxilj 	
 	static const INT tagGpsDestBearingREF 	= (USHORT)0x17;  	// ړIn̕p̒P 		
 	static const INT tagGpsDestBearing 		= (USHORT)0x18;  	// ړI̕pilj 		
 	static const INT tagGpsDestDistanceREF 	= (USHORT)0x19;  	// ړIn܂ł̋̒P 	
 	static const INT tagGpsDestDistance 	= (USHORT)0x1A;  	// ړIn܂ł̋ilj 
 	static const INT tagGpsProcessingMethod = (USHORT)0x1B;  	// ʕ̖
 	static const INT tagGpsAreainFormation 	= (USHORT)0x1C;  	// ʒn_̖
 	static const INT tagGpsDataStamp 	 	= (USHORT)0x1D;  	// GPSt
 	static const INT tagGpsDifferenatial 	= (USHORT)0x1E;  	// GPS␳ʒu

 	static const INT tagGpsHPositioningError 	= (USHORT)0x1F;  	// ʌ덷	+Exif 2.3

};