using System;
using System.Text;
using System.Runtime.InteropServices;


namespace m4iz
{
	///
	///// mgc4iz.dll  Header Ver4.1600a
	///
	///  (C) m.magic & K Maruyama. All rights reserved.
	///
	
	public class miz
	{
        //
	    //// common
	    //
	    public const int success		= 0;
	    public const int failure 		= -1;
 	    public const int mizTrue 		= 1;
 	    public const int mizFalse		= 0;
 	    public const int yes			= mizTrue;
 	    public const int no				= mizFalse;
 	    public const int mizNull		= 0;
 	    public const int maxPath		= 260;
 	    public const int lengthName		= 512;
 	    public const int lengthValue	= 65536;
 	    public const int lengthRawValue = 65536;
	
	    // Error
 	    public const int mizFailure			= -1;
 	    public const int errFile			= -101;
 	    public const int errUnknownFile		= -102;
 	    public const int errNONExif			= -103;
 	    public const int errMemory			= -104;
 	    public const int errNoResource		= -106;
 	    public const int errResource		= -107;
 	    public const int errThumbnailImage	= -108;
 	    public const int errThumbnailMemory = -300;
 	    public const int errFileCopy		= -400;	// 摜t@C̃Rs[sS
 	    public const int errFileWrite		= -401;	// HTMLt@C̏ݕsS
 	    public const int errFormePointer	= -402;	// form ̏s
 	    public const int errFormSize		= -403;	// form ̑TCYs
 	    public const int errFormNotReady	= -404;	// form resourse ̎w肪Ȃ
 	    public const int errFormQueue		= -405;	// ҂s̃TCYs
 	    public const int errFormValiables	= -406;	// form ̕ϐ̐s

        public struct STRING128
		{
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 128)]
			public string s;
		}

        public struct STRING256
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 256)]
            public string s;
        }

		public struct STRING512
		{
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 512)]
			public string s;
		}


	    //
	    //// mizInitialize
	    //
	    // \
        public struct INI_DATA
		{
            [MarshalAs(UnmanagedType.LPWStr)]
			public string resourceFile; // TeCgckk
		}
	    
	    //
	    ////	Begin
	    //
 	    public const uint command			= 0x000000ff;
 	    public const uint options			= 0xffffff00;
 	    public const uint cmdReset			= 0x00000000;
 	    public const uint cmdRead			= 0x00000001;
 	    public const uint cmdBegin			= 0x00000002;
 	    public const uint cmdGetField		= 0x00000003;
 	    public const uint cmdGetThumbnail	= 0x00000004;
 	    public const uint cmdGetFileCrc		= 0x00000005;
 	    public const uint cmdLoadForm		= 0x00000006;
 	    public const uint cmdSaveFile		= 0x00000007;

 	    public const uint optNoReset			= 0x00000000;	// Option for cmdReset
 	    public const uint optResetThumbnail		= 0x00000100;	// Option for cmdReset
 	    public const uint optResetField			= 0x00000200;	// Option for cmdReset
 	    public const uint optUnit				= 0x00000000;	// Option for cmdRead
 	    public const uint optIncludeThumbnail	= 0x00000100;	// Option for cmdRead
 	    public const uint optNonUnit			= 0x00000200;	// Option for cmdRead
 	    public const uint optRise				= 0x00000000;	// Option for cmdBegin
 	    public const uint optDown				= 0x00000100;	// Option for cmdBegin
 	    public const uint optGetStrings			= 0x00000000;	// Option for GetField 
 	    public const uint optGetData			= 0x00000100;	// Option for GetField 
 	    public const uint optCSV				= 0x00000000;	// Option for cmdSAVE_FILE
 	    public const uint optHtmlForm0			= 0x00000100;	// Option for cmdSAVE_FILE
 	    public const uint optHtmlForm1			= 0x00000200;	// Option for cmdSAVE_FILE
 	    public const uint optFileType			= 0x0000ff00;	// Option for cmdSAVE_FILE
	    public const uint optCode				= 0x0fff0000;	// Option for cmdSAVE_FILE
	    public const uint optCodeSJIS			= 0x00000000;	// Option for cmdSAVE_FILE
	    public const uint optCodeUTF8			= 0x00010000;	// Option for cmdSAVE_FILE
	    public const uint optCodeUTF16BE		= 0x00020000;	// Option for cmdSAVE_FILE
	    public const uint optCodeUTF16LE		= 0x00030000;	// Option for cmdSAVE_FILE


 	    public const uint resetALL		    = cmdReset | optResetField | optResetThumbnail;
 	    public const uint resetField		= cmdReset | optResetField;
 	    public const uint resetThumbnail	= cmdReset | optResetThumbnail;
 	    public const uint read			    = cmdRead  | optNonUnit;
 	    public const uint readPlusOne	    = cmdRead  | optIncludeThumbnail | optNonUnit;
 	    public const uint beginRise		    = cmdBegin | optRise;
 	    public const uint beginDown		    = cmdBegin | optDown;
 	    public const uint getStrings		= cmdGetField;
 	    public const uint getData		    = cmdGetField | optGetData;
 	    public const uint getThumbnail	    = cmdGetThumbnail;
 	    public const uint getFieldCRC	    = cmdGetFileCrc;


	    // IFD ̎
 	    public const uint kindIfdTiff				= 0x0000;
 	    public const uint kindIfdExif				= 0x8769;
 	    public const uint kindIfdGps				= 0x8825;
 	    public const uint kindIfdInteroperability	= 0xA005;
 	    public const uint kindIfdThumbnail			= 0x0001;
	    // IFD f[^`
 	    public const uint tifLittleEndian	= 0x4949;	// GfBA`
 	    public const uint tifBigEndian		= 0x4D4D;	// rbOGfBA`
	    //// IFD Type
 	    public const uint ifdTypeByte		= 1;	// 8 rbgB
 	    public const uint ifdTypeAscii		= 2;	// 7 sbgASCII R[h[߂8 rbgoCgB
 	    public const uint ifdTypeShort		= 3;	// 16 rbgi2 oCgjB
 	    public const uint ifdTypeLong		= 4; 	// 32 rbgi4 oCgjB
 	    public const uint ifdTypeRational	= 5; 	// _u LONGBŏLONG ͕qA2 ڂLONG ͕\B
 	    public const uint ifdTypeUndefined	= 7; 	// tB[h̒`ɂAǂȒlƂĂǂ8 rbgoCgB
 	    public const uint ifdTypeSLong		= 9; 	// 32 rbgi4 oCgjti2 ̕␔\jB
 	    public const uint ifdTypeSrational	= 10; 	// _u SLONGBŏSLONG ͕qA2 ڂSLONG ͕\B

	    // html resource ID
 	    public const int idrHtmlForm0	= 64000;	// idrHtmlForm0 for openoffice ;	
 	    public const int idrHtmlForm1	= 64001;	// idrHtmlForm1 for microsoft office;	
	    // html form
 	    public const int formField			= 0;
 	    public const int formHeader			= 1;
 	    public const int formImage			= 2;
 	    public const int formFieldsHeader	= 3;
 	    public const int formOther			= 4;
 	    public const int formFreeOne		= 5;
 	    public const int formFooter			= 6;
 	    public const int formMetadata0s		= 7;
 	    public const int formMetadata1s		= 8;	// ms form
 	    public const int formMetadata2s		= 9;	// ms form
 	    public const int formStructure0		= 10;
 	    public const int formStructure1		= formStructure0;
 	    public const int formMax			= 11;
 	    public const int formCount0			= 9;
 	    public const int formCount1			= formMax;

	    // size of html form ////////////////////////////////////////////////////////////////////////////// 
	    // If FORM of a resource is changed, it is necessary to change the form size. 
	    // Please change a required line. 	-->
 	    public const int formLengthDontUse			= 0;
 	    public const int formLengthField			= 285;
 	    public const int formLengthHeader			= 226;
 	    public const int formLengthFieldsHeader		= 347;
 	    public const int formLengthImage			= 204;
 	    public const int formLengthOther			= 71;
 	    public const int formLengthFreeOne			= 3;
 	    public const int formLengthFooter			= 91;
 	    public const int formLengthMetadata0s		= 33;
 	    public const int formLengthMetadata1s		= 19;
 	    public const int formLengthMetadata2s		= 30;
 	    public const int formLengthStructure0		= 505;
 	    public const int formLengthStructure1		= 874;
 	    public const int form0Length				= 1765;
 	    public const int form1Length				= 2183;

 	    public const int formEnuLengthSrtructure0	= 494;
 	    public const int formEnuLengthSrtructure1	= 862;
 	    public const int form0EnuLength				= 1754;
 	    public const int form1EnuLength				= 2171;
	    // <-- 

	    // Elements for Form
 	    public const int elementDontOutput		= 0;
 	    public const int elementHeader			= 1;
 	    public const int elementImage			= 2;
 	    public const int elementFieldHeader		= 3;
 	    public const int elementFields			= 4;
 	    public const int elementOther0			= 5;
 	    public const int elementOther1			= 6;
 	    public const int elementOther2			= 7;
 	    public const int elementOther3			= 8;
 	    public const int elementOther4			= 9;
 	    public const int elementOther5			= 10;
 	    public const int elementOther6			= 11;
 	    public const int elementOther7			= 12;
 	    public const int elementOther8			= 13;
 	    public const int elementOther9			= 14;
 	    public const int elementFreeOne0		= 15;
 	    public const int elementFreeOne1		= 16;
 	    public const int elementFreeOne2		= 17;
 	    public const int elementFreeOne3		= 18;
 	    public const int elementFreeOne4		= 19;
 	    public const int elementFreeOne5		= 20;
 	    public const int elementFreeOne6		= 21;
 	    public const int elementFreeOne7		= 22;
 	    public const int elementFreeOne8		= 23;
 	    public const int elementFreeOne9		= 24;
 	    public const int elementFooter			= 25;
 	    public const int elementsMax			= 25;
 	    public const int elementsOtherMax		= 10;
 	    public const int elementsFreeOneMax		= 10;
	    // structure
 	    public const int structureSizeA	= 512;
	    // structure
 	    public const int headerSizeA		= 256;
 	    public const int headerSizeB		= 128;
	    // kind of metadata
 	    public const int metadataMax		= 24;
 	    public const int metadataSizeA		= 512;
 	    public const int metadataSizeB		= 128;
	    // field
 	    public const int fieldSizeA	= 128;
	    // other
 	    public const int otherSizeA	= 512;
	    // free one
 	    public const int freeOneSizeA	= 512;
	    // footer
 	    public const int footerSizeA	= 256;
	    // csv
 	    public const int csvSizeA		= 512;
 	    public const int csvSizeB		= 128;
 	    public const int csvMaxCount	= 16;


	    //
	    //// ߂l
	    //
	    public const int lastField = 100;

	    //
	    //// \
	    //
        public struct FIELD_DATA
		{
			public ushort	endian;
			public ushort	tag;
			public ushort	type;
			public int      count;
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = lengthValue)]
			public byte[] values;
			public void initialize()
			{
				values = new byte[lengthValue];
			}
		} 

        public struct FIELD_STRINGS
		{
			public uint		kindIFD;
			public ushort	tag;
			public string	name;
			public string	values;
		}

		public struct TEXT_SIZE
		{
			public int name;
			public int value;
			public int rawValues;
		}

        // thambnail
		public struct THUMBNAIL_IMAGE
		{
			public int compression;
			public int size;
			public IntPtr image;
		}

        // Html resource
		public struct HTML_RESOURCE
		{
			public int		id;
			public int		totalLength;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = formMax)]
			public int[]	length;
			public void initialize()
			{
				length = new int[formMax];
			}
		}

        // method for html
		public struct METHOD_FOR_FORM0
		{
			// TARGET
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst = maxPath)]
			public string	path;											    // Html o͐ = %drive%\x1
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst = maxPath)]
			public string	fileName;											// K .htm t
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = elementsMax)]
			public int[]	queue;			// elements ̏o͏
			public int		queueCount;		// Queue ̐

			// STRUCTURE
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst = structureSizeA)]
			public string	title;
			// METADATAS
			public int	countForMetadata0s;
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = metadataMax)]
			public STRING128[]	nameOfMetadata0;
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = metadataMax)]
			public STRING512[]	contentOfMetadata0;

			// ȉ elements -->
			// HEADER
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = headerSizeA)]
			public string	headerTitle;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = headerSizeB)]
			public string	date;
			// IMAGE
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = maxPath)]
			public string	imagePathAndName;	// 摜̏ꏊƃt@C = %drive%\folder\image.jpg
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = maxPath)]
			public string	imageName;			// 摜t@C = image.jpg
			public int		imageWidth;
			public int		imageHeight;
			// FIELDS HEADER
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
			public STRING128[] fieldName;
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = 5)] 
			public STRING128[] kind;
			// OTHER
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = elementsOtherMax)]
			public STRING512[] other;
			// FREEONE
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = elementsFreeOneMax)]
			public STRING512[] freeOne;
			// FOOTER
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = footerSizeA)]
			public string footer;
			// <-- elements

			public void initialize()
			{
				queue = new int[elementsMax];
				nameOfMetadata0 = new STRING128[metadataMax];
				contentOfMetadata0 = new STRING512[metadataMax];
				fieldName = new STRING128[4];
				kind  = new STRING128[5];
				other = new STRING512[elementsOtherMax];
				freeOne = new STRING512[elementsFreeOneMax];
			}
		}
		
		public struct METHOD_FOR_FORM1
		{
            // TARGET
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = maxPath)]
            public string path;											    // Html o͐ = %drive%\x1
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = maxPath)]
            public string fileName;											// K .htm t
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = elementsMax)]
            public int[] queue;			// elements ̏o͏
            public int queueCount;		// Queue ̐

            // STRUCTURE
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = structureSizeA)]
            public string title;
            // METADATAS
            public int countForMetadata0s;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = metadataMax)]
            public STRING128[] nameOfMetadata0;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = metadataMax)]
            public STRING512[] contentOfMetadata0;

            // ȉ elements -->
            // HEADER
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = headerSizeA)]
            public string headerTitle;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = headerSizeB)]
            public string date;
            // IMAGE
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = maxPath)]
            public string imagePathAndName;	// 摜̏ꏊƃt@C = %drive%\folder\image.jpg
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = maxPath)]
            public string imageName;			// 摜t@C = image.jpg
            public int imageWidth;
            public int imageHeight;
            // FIELDS HEADER
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
            public STRING128[] fieldName;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 5)]
            public STRING128[] kind;
            // OTHER
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = elementsOtherMax)]
            public STRING512[] other;
            // FREEONE
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = elementsFreeOneMax)]
            public STRING512[] freeOne;
            // FOOTER
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = footerSizeA)]
            public string footer;
            // <-- elements

			// METADATAS1
			public int	countForMetadata1s;
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = metadataMax)]
			public STRING128[]	nameOfMetadata1;
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = metadataMax)]
			public STRING512[]	contentOfMetadata1;
			// METADATAS2
			public int	countForMetadata2s;
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = metadataMax)]
			public STRING128[]	nameOfMetadata2;
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = metadataMax)]
			public STRING128[]	typeOfMetadata2;
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = metadataMax)]
			public STRING512[]	contentOfMetadata2;


			public void initialize()
			{
				queue = new int[elementsMax];
				nameOfMetadata0 = new STRING128[metadataMax];
				contentOfMetadata0 = new STRING512[metadataMax];
				fieldName = new STRING128[4];
				kind  = new STRING128[5];
				other = new STRING512[elementsOtherMax];
				freeOne = new STRING512[elementsFreeOneMax];
			
				nameOfMetadata1 = new STRING128[metadataMax];
				contentOfMetadata1 = new STRING512[metadataMax];
				nameOfMetadata2 = new STRING128[metadataMax];
				typeOfMetadata2 = new STRING128[metadataMax];
				contentOfMetadata2 = new STRING512[metadataMax];
			}
		}
        		
		// csv
		public struct METHOD_FOR_CSV
		{
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst = maxPath)]
			public string	path;	    // csv o͐ = %drive%\x1
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst = maxPath)]
			public string	fileName;	// K .csv t
            
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = 5)]
			public STRING128[] kind;
			public int		count;
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = csvMaxCount)]
			public STRING512[] name;
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = csvMaxCount)]
			public STRING512[] value_;

			public void initialize()
			{
				kind = new STRING128[5];
				name = new STRING512[csvMaxCount];
				value_ = new STRING512[csvMaxCount];
			}
		}


	    //
	    //// Tiff IFD TAG
    	//
 	    public const uint tagImageWidth					= 0x100;	// 摜̕ 
 	    public const uint tagImageLength				= 0x101;	// 摜̍ 
 	    public const uint tagBitSperSample				= 0x102;	// 摜̃rbg̐[
 	    public const uint tagCompression				= 0x103;	// k̎
 	    public const uint tagPhotoMetricuinterpretation	= 0x106;	// f\
 	    public const uint tagThreshholding				= 0x107;	// 臒l
 	    public const uint tagCellWidth 			 		= 0x108; 	// Z
 	    public const uint tagCellLength 				= 0x109; 	// Z
 	    public const uint tagFillorder 			 		= 0x10A; 	// tBI[_[
 	    public const uint tagDocumentName 			 	= 0x10D; 	// ͉摜
 	    public const uint tagImageDescriotion			= 0x10E;	// 摜^Cg
 	    public const uint tagMake 						= 0x10F;	// 摜͋@̃[J[
 	    public const uint tagModel						= 0x110;	// 摜͋@̃f
 		public const uint tagStripOffsets				= 0x111;	// 摜f[^̃P[V 
 		public const uint tagOrientation				= 0x112;	// 摜
 		public const uint tagSamplesPerPixel			= 0x115;	// R|[lg
 		public const uint tagRowSperstrip				= 0x116;	// XgbṽC
 		public const uint tagStripByteCounts 			= 0x117;	// Xgbṽf[^
 		public const uint tagMinSampleValue 			= 0x118; 	// ŏTvOl
 		public const uint tagMaxSampleValue 			= 0x119; 	// őTvOl
 		public const uint tagXresolution 				= 0x11A;	// 摜̉̕𑜓x
 		public const uint tagYresolution 				= 0x11B;	// 摜̍̉𑜓x
 		public const uint tagPlanarConfiguration 		= 0x11C;	// 摜f[^̕
 		public const uint tagPageName 			 		= 0x11D; 	// ͉摜y[W
 		public const uint tagXposition 			 		= 0x11E; 	// 摜̂wʒu
 		public const uint tagYposition 			 		= 0x11F; 	// 摜̂xʒu
 		public const uint tagFreeOffsets 			 	= 0x120; 	// f[^ʒu
 		public const uint tagFreeByteCounts 			= 0x121; 	// f[^
 		public const uint tagGrayResponseUnit 		 	= 0x122; 	// OCX|XP
 		public const uint tagGrayResponseCurve 		 	= 0x123; 	// OCX|X
 		public const uint tagT4Options 			 		= 0x124; 	// T4 IvV
 		public const uint tagT6Options 			 		= 0x125; 	// T6 IvV
 		public const uint tagResolutionUnit 			= 0x128;	// 摜̕ƍ̉𑜓x̒P
 		public const uint tagPageNumber 			 	= 0x129; 	// ͉摜y[W
 		public const uint tagTransferFunction 			= 0x12D;	// ĐKJ[u 
 		public const uint tagSoftware 					= 0x131;	// gp\tgEFA
 		public const uint tagDateTime 					= 0x132;	// t@CύX 
 		public const uint tagArtist 					= 0x13B;	// Җ 
 		public const uint tagHostComputer 			 	= 0x13C; 	// zXgRs[^[
 		public const uint tagPredictor 			 		= 0x13D; 	// Predictor
 		public const uint tagWhitePoint 				= 0x13E;	// QƔF_̐FxWl
 		public const uint tagPrimaryChromaticities 		= 0x13F;	// F̐FxWl
 		public const uint tagColorMap 			 		= 0x140; 	// J[pbg
 		public const uint tagHalfTonehints 			 	= 0x141; 	// n[tg[
 		public const uint tagTileWidth 			 		= 0x142; 	// ^C
 		public const uint tagTileLength 			 	= 0x143; 	// ^C
 		public const uint tagTileOffsets 			 	= 0x144; 	// ^CItZbgʒu
 		public const uint tagTileByteCounts 			= 0x145; 	// ^CoCg
 		public const uint tagInkSet 					= 0x14C; 	// CNZbg
 		public const uint tagInkNames 			 		= 0x14D; 	// CN
 		public const uint tagNumberOfInks 			 	= 0x14E; 	// CN
 		public const uint tagDotRange 			 		= 0x150; 	// hbgW
 		public const uint tagTargetPrinter 			 	= 0x151; 	// v^
 		public const uint tagExtraSamples 			 	= 0x152; 	// ǉf\
 		public const uint tagSampleFormat 			 	= 0x153; 	// W{
 		public const uint tagSMinSampleValue 		 	= 0x154; 	// ŏ̕W{l
 		public const uint tagSMAXSampleValue 		 	= 0x155; 	// ő̕W{l
 		public const uint tagTransferRange 			 	= 0x156; 	// TransferRange
 		public const uint tagJPEGProc 			 		= 0x200; 	// JPEGProc
 		public const uint tagJPEGIntercahngeFormat 		= 0x201;	// JPEG SOI ւ̃ItZbg
 		public const uint tagJPEGIntercahngeFormatLength = 0x202;	// JPEG f[^̃oCg
 		public const uint tagJPEGRestartInterval 		= 0x203; 	// JPEGResetartInterval
 		public const uint tagJPEGLosslessPredictors		= 0x205; 	// JPEGLosslessPredictors 
 		public const uint tagJPEGPointTransforms		= 0x206; 	// JPEGPointTransforms 
 		public const uint tagJPEGQTables				= 0x207; 	// JPEGQTables 
 		public const uint tagJPEGDCTables				= 0x208; 	// JPEGDCTables
 		public const uint tagJPEGACTables				= 0x209; 	// JPEGACTables
 		public const uint tagYcBcRCoefficients			= 0x211;	// Fϊ}gNXW
 		public const uint tagYcBcRSUBSAMPLING			= 0x212;	// YCC ̉f\iC ̊Ԉj
 		public const uint tagYcBcRPositionING			= 0x213;	// YCC ̉f\iY C ̈ʒuj
 		public const uint tagReferenceBlackWhite		= 0x214;	// QƍF_lƎQƔF_l
 		public const uint tagCopyright					= 0x8298;	// Be쌠/ҏW쌠 
 		public const uint tagExifIFDpointer				= 0x8769;	// Exif 
 		public const uint tagGPSINFOpointer				= 0x8825;	// GPS 
 		public const uint tagNewSubFileType			 	= 0xFE; 	// VTut@C^
 		public const uint tagSubFileType 			 	= 0xFF; 	// Tut@C^


	    //
	    //// Exif IFD TAG
	    //
 		public const uint tagExposureTime				= 0x829A;	// Io
 		public const uint tagFnumber 					= 0x829D;	// F io[ 
 		public const uint tagExposureProgram 	 		= 0x8822;	// IovO 
 		public const uint tagSpectralSensitivity 	 	= 0x8824;	// XyNgx 
 		public const uint tagISOSpeedRatings 	 		= 0x8827;	// ISOXs[h[g 
 		public const uint tagOECF 						= 0x8828;	// dϊ֐ 

 		public const uint tagSensitivityType			= 0x8830;	// x						+Exif 2.3
 		public const uint tagSTANDERDOutputSensitivity	= 0x8831;	// Wo͊x					+Exif 2.3
 		public const uint tagRecommendedExposureIndex	= 0x8832;	// Iw					+Exif 2.3
 		public const uint tagISOSpeed					= 0x8833;	// ISOXs[h					+Exif 2.3
 		public const uint tagISOSpeedLatitudeYYY		= 0x8834;	// ISOXs[h``[h YYY	+Exif 2.3
 		public const uint tagISOSpeedLatitudeZZZ		= 0x8835;	// ISOXs[h``[h ZZZ	+Exif 2.3

 		public const uint tagExifVersion 				= 0x9000;	// Exif o[W 		
 		public const uint tagDateTimeOriginal  			= 0x9003;	// 摜f[^̐ 		
 		public const uint tagDateTimeDigitized  		= 0x9004;	// fBW^f[^̍쐬 	
 		public const uint tagComponentsConfiguration 	= 0x9101;	// eR|[lg̈Ӗ 		
 		public const uint tagCompressedBitSperPixel 	= 0x9102;	// 摜k[h 			
 		public const uint tagShutterSpeedValue 	 		= 0x9201;	// Vb^[Xs[h 
 		public const uint tagApertureValue 				= 0x9202;	// il 
 		public const uint tagBrightnessValue 	 		= 0x9203;	// Pxl 
 		public const uint tagExposureBiasValue 	 		= 0x9204;	// I␳l 
 		public const uint tagMaxApertureValue 	 		= 0x9205;	// Yŏel 
 		public const uint tagSubjectDistance 	 		= 0x9206;	// ʑ̋ 
 		public const uint tagMeteringMode 				= 0x9207;	//  
 		public const uint tagLightSource 				= 0x9208;	//  
 		public const uint tagFlash 						= 0x9209;	// tbV
 		public const uint tagFocalLength 				= 0x920A;	// Yœ_ 
 		public const uint tagSubjectarea				= 0x9214;	// ʑ̗̈					
 		public const uint tagMakerNote 					= 0x927C;	// [J[m[g 				
 		public const uint tagUserComment 				= 0x9286;	// [U[Rg 			
 		public const uint tagSubsecTime 				= 0x9290;	// DateTime ̃TuZbN 			
 		public const uint tagSubsecTimeOriginal 		= 0x9291;	// DateTimeOriginal ̃TuZbN 		
 		public const uint tagSubsecTimeDigitized 		= 0x9292;	// DateTimeDigitized ̃TuZbN 		
 		public const uint tagFlashpixVersion 			= 0xA000;	// ΉtbVsbNXo[W 	
 		public const uint tagColorSpace 				= 0xA001;	// Fԏ 				
 		public const uint tagPixelXdimension 			= 0xA002;	// 摜 				
 		public const uint tagPixelYdimension 			= 0xA003;	// 摜 				
 		public const uint tagRelatedSoundFile 			= 0xA004;	// ֘At@C 			
 		public const uint tagInteroperabilityIFDpointer	= 0xA005;	// ݊IFD ւ̃|C^
 		public const uint tagFLASHENERGY 				= 0xA20B;	// tbVx 
 		public const uint tagSPATIALFREQUENCYResponse	= 0xA20C;	// Ԏg 
 		public const uint tagFOCALPLANEXResolution 		= 0xA20E;	// œ_ʂ̉̕𑜓x 
 		public const uint tagFOCALPLANEYResolution 		= 0xA20F;	// œ_ʂ̍̉𑜓x 
 		public const uint tagFOCALPLANEResolutionUnit 	= 0xA210;	// œ_ʉ𑜓xP 
 		public const uint tagSubjectLOCATION 			= 0xA214;	// ʑ̈ʒu 
 		public const uint tagExposureIndex 				= 0xA215;	// IoCfbNX 
 		public const uint tagSensingMethod 				= 0xA217;	// ZT[ 
 		public const uint tagFileSource 				= 0xA300;	// t@C\[X 
 		public const uint tagSCENEType 					= 0xA301;	// V[^Cv 
 		public const uint tagCfaPattern 				= 0xA302;	// FA p^[ 

 		public const uint tagCustomRendered 			= 0xA401;	// JX^C[W			
 		public const uint tagExposureMode 				= 0xA402;	// Io[h					
 		public const uint tagWhiteBalance 				= 0xA403;	// zCgoX				
 		public const uint tagDigitalZoomRatio 			= 0xA404;	// fBW^Y[			
 		public const uint tagFocalLengthIn35mmFilm 		= 0xA405;	// RTZYœ_	
 		public const uint tagSceneCaptureType 			= 0xA406;	// V[Be^Cv				
 		public const uint tagGainControl 				= 0xA407;	// QCRg[			
 		public const uint tagContrast 					= 0xA408;	// RgXg					
 		public const uint tagSaturation 				= 0xA409;	// ʓx							
 		public const uint tagSharpness 					= 0xA40A;	// V[vlX					
 		public const uint tagDEviceSettingDescription 	= 0xA40B;	// @ݒ					
 		public const uint tagSubjectDistanceRange 		= 0xA40C;	// ʑ͈̂̋				
 		public const uint tagImageUniqueID 				= 0xA420;	// Ǝ̉摜 ID				

 		public const uint tagCameraOwnerName			= 0xA430;	// JLҖ		+Exif 2.3
 		public const uint tagBodySerialNumber			= 0xA431;	// JVAԍ	+Exif 2.3
 		public const uint tagLensSpecification			= 0xA432;	// Ydl		+Exif 2.3
 		public const uint tagLensMake					= 0xA433;	// Y[J[		+Exif 2.3
 		public const uint tagLensMode					= 0xA434;	// Yf		+Exif 2.3
 		public const uint tagLensSerialNumber			= 0xA435;	// YVAԍ	+Exif 2.3

 		public const uint tagGamma						= 0xA500;	// ĐK}		+Exif 2.3

	    //
	    //// GPS IFD TAG
	    //
 		public const uint tagGpsVersionID 		= 0x0; 		// GPS ^Õo[W 	
 		public const uint tagGpsLatitudeREF 	= 0x1;  	// k(N)or (S) 		
 		public const uint tagGpsLatitude 		= 0x2;  	// ܓxilj 			
 		public const uint tagGpsLongitudeREF 	= 0x3;  	// o(E)or o(W) 		
 		public const uint tagGpsLongitude 		= 0x4;  	// oxilj 			
 		public const uint tagGpsAltitudeREF 	= 0x5;  	// x̒P 				
 		public const uint tagGpsAltitude 		= 0x6;  	// xilj 			
 		public const uint tagGpsTimeStamp 		= 0x7;   	// GPS ԁiqv̎ԁj
 		public const uint tagGpsSatellites 		= 0x8;   	// ʂɎgqM 	
 		public const uint tagGpsStatus 			= 0x9;   	// GPS M@̏ 		
 		public const uint tagGpsMeasureMode 	= 0xA;   	// GPS ̑ʕ@ 			
 		public const uint tagGpsDOP 			= 0xB;   	// ʂ̐M 			
 		public const uint tagGpsSpeedREF 		= 0xC;   	// x̒P 				
 		public const uint tagGpsSpeed 			= 0xD;   	// xilj 			
 		public const uint tagGpsTrackREF 		= 0xE;   	// is̒P 			
 		public const uint tagGpsTrack 			= 0xF;   	// isilj 		
 		public const uint tagGpsImgDirectionREF = 0x10;  	// Be摜̒̕P 
 		public const uint tagGpsImgDirection 	= 0x11;  	// Be摜̕ilj
 		public const uint tagGpsMapDatum 		= 0x12;  	// ʂɗpn}f[^ 	
 		public const uint tagGpsDestLatitudeREF = 0x13;  	// ړIn̖k(N)or (S)
 		public const uint tagGpsDestLatitude 	= 0x14;  	// ړIn̈ܓxilj 	
 		public const uint tagGpsDestLongitudeREF = 0x15;  	// ړIn̓o(E)or o(W)
 		public const uint tagGpsDestLongitude 	= 0x16;  	// ړIňoxilj 	
 		public const uint tagGpsDestBearingREF 	= 0x17;  	// ړIn̕p̒P 		
 		public const uint tagGpsDestBearing 	= 0x18;  	// ړI̕pilj 		
 		public const uint tagGpsDestDistanceREF = 0x19;  	// ړIn܂ł̋̒P 	
 		public const uint tagGpsDestDistance 	= 0x1A;  	// ړIn܂ł̋ilj 
 		public const uint tagGpsProcessingMethod = 0x1B;  	// ʕ̖
 		public const uint tagGpsAreainFormation = 0x1C;  	// ʒn_̖
 		public const uint tagGpsDataStamp 	 	= 0x1D;  	// GPSt
 		public const uint tagGpsDifferenatial 	= 0x1E;  	// GPS␳ʒu

 		public const uint tagGpsHPositioningError 	= 0x1F;  	// ʌ덷	+Exif 2.3


		[DllImport("mgc4iz.dll", CharSet = CharSet.Unicode)]
		public static extern int mizInitialize(ref INI_DATA intialData);

		[DllImport("mgc4iz.dll", CharSet = CharSet.Unicode)]
		public static extern int mizBegin(uint functions, IntPtr parameters);
		[DllImport("mgc4iz.dll", CharSet = CharSet.Unicode)]
		public static extern int mizBegin(uint functions, ref FIELD_DATA parameters);
		[DllImport("mgc4iz.dll", CharSet = CharSet.Unicode)]
		public static extern int mizBegin(uint functions, ref FIELD_STRINGS parameters);
		[DllImport("mgc4iz.dll", CharSet = CharSet.Unicode)]
		public static extern int mizBegin(uint functions, ref TEXT_SIZE parameters);
		[DllImport("mgc4iz.dll", CharSet = CharSet.Unicode)]
		public static extern int mizBegin(uint functions, ref THUMBNAIL_IMAGE parameters);
		[DllImport("mgc4iz.dll", CharSet = CharSet.Unicode)]
		public static extern int mizBegin(uint functions, string parameters);
		[DllImport("mgc4iz.dll", CharSet = CharSet.Unicode)]
		public static extern int mizBegin(uint functions, ref METHOD_FOR_FORM0 parameters);
		[DllImport("mgc4iz.dll", CharSet = CharSet.Unicode)]
		public static extern int mizBegin(uint functions, ref METHOD_FOR_FORM1 parameters);
		[DllImport("mgc4iz.dll", CharSet = CharSet.Unicode)]
		public static extern int mizBegin(uint functions, ref METHOD_FOR_CSV parameters);
		[DllImport("mgc4iz.dll", CharSet = CharSet.Unicode)]
		public static extern int mizBegin(uint functions, ref HTML_RESOURCE parameters);

		[DllImport("mgc4iz.dll", CharSet = CharSet.Unicode)]
		public static extern int mizGetFileVersion(     string file,
													ref uint major, 
													ref uint minor,
													ref uint revision,
													ref uint bild	);
		
	}
}
