// TestIZDlg.cpp : t@C
//
#include "stdafx.h"
#include "TestIZ.h"
#include "TestIZDlg.h"
#include <strsafe.h>



#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
private:
	CM4iz*	m_lpIZ;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	m_lpIZ = &theApp.m_IZ;
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
//	ON_WM_CREATE()
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	static const INT nID[]		= { IDC_STATIC2, IDC_STATIC3, IDC_STATIC4, IDC_STATIC5 };
#if _AMD64
	static LPCTSTR lpFile[] = {	_T("TestIZ64.exe"),
								_T("mgc4iz.dll"),
								_T("miz4jpn.dll"),
								_T("miz4enu.dll") };
#else
	static LPCTSTR lpFile[]	= { _T("TestIZ32.exe"),
								_T("mgc4iz.dll"),
								_T("miz4jpn.dll"),
								_T("miz4enu.dll") };
#endif

	TCHAR	szVersion[64];
	DWORD	dwMajor;
	DWORD	dwMinor;
	DWORD	dwRevision;
	DWORD	dwBild;
	

	for(INT nI = 0; nI < 4; nI++) 
	{
		dwMajor = dwMinor = dwRevision = dwBild = 0;
		m_lpIZ->GetFileVersion(CT2W(lpFile[nI]), &dwMajor, &dwMinor, &dwRevision, &dwBild);

		StringCchPrintf(	szVersion,
							64,
							_T("%s\tVersion %d.%d.%d.%d"),
							lpFile[nI],
							dwMajor,
							dwMinor,
							dwRevision,
							dwBild		);
				
		SetDlgItemText(nID[nI], szVersion);
	}
			
	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CTestIZDlg::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


// CTestIZDlg _CAO
CTestIZDlg::CTestIZDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestIZDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_lpIZ = &theApp.m_IZ;
	m_szFileName[0] = 0;
	m_szPathAndName[0] = 0;
	m_szThumbnailPathAndName[0] = 0;
	m_szThumbnailName[0] = 0;
}

void CTestIZDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_List1);
	DDX_Control(pDX, IDC_STATIC1, m_txtFileName);
	DDX_Control(pDX, IDC_STATIC2, m_txtEndian);
}

BEGIN_MESSAGE_MAP(CTestIZDlg, CDialog)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_CSV, &CTestIZDlg::OnFileCsv)
	ON_COMMAND(ID_FILE_HTML_FORM0, &CTestIZDlg::OnFileHtmlForm0)
	ON_COMMAND(ID_FILE_HTML_FORM1, &CTestIZDlg::OnFileHtmlForm1)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SYSCOMMAND()
END_MESSAGE_MAP()


// CTestIZDlg bZ[W nh
int CTestIZDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialog::OnCreate(lpCreateStruct)  ==  -1)
		return -1;
	
	// TODO :  ɓȍ쐬R[hǉĂB
	return 0;
}

BOOL CTestIZDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
		
	//
	//// \[XĂTeCgckkw肵܂
	//
	LPCTSTR lpszResource[] = { _T("miz4jpn.dll"), _T("miz4enu.dll"), _T("") };
			
	switch(AfxMessageBox(_T("{?"), MB_YESNOCANCEL | MB_ICONQUESTION))
	{
	case IDYES:
		m_nResource = 0;
		break;
	case IDNO:
		m_nResource = 1;
		break;
	default:
		m_nResource = 2;	// RAW f[^̂ݎ擾
	}

	TCHAR szError[64];
	int nResult;
	
	nResult = m_lpIZ->Initialize(lpszResource[m_nResource]);
	StringCchPrintf(szError, 64, _T("Error = %d"), nResult);
	
	//nResult = m_lpIZ->UnloadResource();

	m_txtEndian.SetWindowText(szError);
	
	//
	//// Xg
	//
	LPCTSTR	lpszTopItem[2][4]	= { _T("Kind"), _T("Tag")	, _T("IFD NAME"), _T("IFD Value"),
									_T("Tag") , _T("Type")	, _T("Count")	, _T("IFD Value")	}; 
	INT     nWidth[2][4]		= { 60	, 60	, 200	, 800,
									60	, 80	, 60	, 920	};
	INT	nI;
	INT	nListCount = m_List1.GetItemCount();
	INT nN = (m_nResource == 2)? 1 : 0;

	for(nI = 0; nI < 4; nI++) 
	{
		m_List1.InsertColumn(nI, lpszTopItem[nN][nI], LVCFMT_LEFT, nWidth[nN][nI]);
	}
	
	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CTestIZDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B
void CTestIZDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); // `̃foCX ReLXg
		CDialog::OnPaint();

		HBITMAP bmp = m_imgThumbnail;

		if(bmp != NULL)
			m_imgThumbnail.Draw(dc.m_hDC, 770, 25);
	}
}

//[U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CTestIZDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTestIZDlg::OnFileCsv()
{
	//
	//// CSV t@C֏
	//
	INT		nResult = CMGC4IZ::failure;
	TCHAR	szText[512];
	TCHAR	szPath[MAX_PATH];
	CMGC4IZ::LPMETHOD_FOR_CSV	lpMethod;
	

	// path name for csv
	if(!ShowDirectoryListBox(szPath, MAX_PATH))
		return;
	
	lpMethod  = new CMGC4IZ::METHOD_FOR_CSV;

	// o͐
	StringCchPrintfA(lpMethod->szPath, MAX_PATH, CT2A(szPath));	// %drive%\x1
	StringCchPrintfA( lpMethod->szFileName,
					  MAX_PATH,
					  "%s.%d.csv", 
					  m_szFileName, 
					  m_nResource	);	// x.csv Kgq́A.cvs	

	// Title
	StringCchPrintfA(lpMethod->szKinds[0], CMGC4IZ::csvSizeB, "Tiff");
	StringCchPrintfA(lpMethod->szKinds[1], CMGC4IZ::csvSizeB, "Exif");
	StringCchPrintfA(lpMethod->szKinds[2], CMGC4IZ::csvSizeB, "GPS");
	StringCchPrintfA(lpMethod->szKinds[3], CMGC4IZ::csvSizeB, "Interoperability");
	StringCchPrintfA(lpMethod->szKinds[4], CMGC4IZ::csvSizeB, "Thumbnail");

	// Free
	StringCchPrintfA(lpMethod->szNames[0],	CMGC4IZ::csvSizeA, "File Name");
	StringCchPrintfA(lpMethod->szValues[0], CMGC4IZ::csvSizeA, "%s", m_szFileName);
	StringCchPrintfA(lpMethod->szNames[1],	CMGC4IZ::csvSizeA, "ꏊ");
	StringCchPrintfA(lpMethod->szValues[1], CMGC4IZ::csvSizeA, CT2A(szPath));
	StringCchPrintfA(lpMethod->szNames[2],	CMGC4IZ::csvSizeA, "date");
	StringCchPrintfA(lpMethod->szValues[2], CMGC4IZ::csvSizeA, "2000/5/5");
	StringCchPrintfA(lpMethod->szNames[3],	CMGC4IZ::csvSizeA, "쐬");
	StringCchPrintfA(lpMethod->szValues[3], CMGC4IZ::csvSizeA, "MR.x");
	StringCchPrintfA(lpMethod->szNames[4],	CMGC4IZ::csvSizeA, "TCY");
	StringCchPrintfA(lpMethod->szValues[4], CMGC4IZ::csvSizeA, "200k");
	
	lpMethod->nCount = 5;


	nResult = m_lpIZ->Begin(CMGC4IZ::cmdSaveFile | CMGC4IZ::optCSV | CMGC4IZ::optCodeUTF8, lpMethod);

	StringCchPrintf(szText, 512, _T("Error = %d"), nResult);
	AfxMessageBox(szText, MB_OK | MB_ICONINFORMATION);

	delete lpMethod;
}

void CTestIZDlg::OnFileHtmlForm0()
{
	//
	//// HTML t@Cւ̏
	//
	static BOOL bOutputImage = TRUE;

	INT		nResult = CMGC4IZ::failure;
	TCHAR	szText[512];
	TCHAR	szPath[MAX_PATH];
	CMGC4IZ::LPMETHOD_FOR_FORM0	lpMethod;
	

	// load form
	nResult = m_lpIZ->LoadHtmlForm(m_nResource == 0, CMGC4IZ::idrHtmlForm0);

	if(nResult != CMGC4IZ::success)
	{
		StringCchPrintf(szText, 512, _T("Error = %d"), nResult);
		AfxMessageBox(szText, MB_OK | MB_ICONINFORMATION);
		return;
	}

	nResult = CMGC4IZ::failure;

	// path name for html
	if(!ShowDirectoryListBox(szPath, MAX_PATH))
		return;
	
	lpMethod = new CMGC4IZ::METHOD_FOR_FORM0;

	// TARGET iHTML o͐j
	StringCchPrintfA(lpMethod->szPath, MAX_PATH, CT2A(szPath));	// %drive%\x1
	StringCchPrintfA( lpMethod->szFileName,
					  MAX_PATH,
					  "%s.ooo.%d.htm",
					  m_szFileName,
					  m_nResource		);	// x.htm Kgq́A.htm	

	// elements ̏o͏
	//
	//	elements ɏo͂lݒ肷Bɐݒ肵vfzO珇ɏo͂B
	//	vfɂ́ACMGC4IZ::elementImage/CMGC4IZ::elementFields/CMGC4IZ::elementFieldHeader/CMGC4IZ::elementOther*
	//	BOTHER ɂ͔Cӂȕo͂łBCMGC4IZ::elementDontOutput == 0 ͏o͂ȂB
	//	̂𕡐o͂邱Ƃ\
	lpMethod->nQueue[0]	 = CMGC4IZ::elementHeader;
	lpMethod->nQueue[1]	 = (bOutputImage)? CMGC4IZ::elementImage : CMGC4IZ::elementDontOutput;	
	lpMethod->nQueue[2]	 = CMGC4IZ::elementOther0;
	lpMethod->nQueue[3]	 = CMGC4IZ::elementFieldHeader;
	lpMethod->nQueue[4]	 = CMGC4IZ::elementFields;
	lpMethod->nQueue[5]	 = CMGC4IZ::elementOther4;
	lpMethod->nQueue[6]	 = CMGC4IZ::elementOther5;
	lpMethod->nQueue[7]	 = CMGC4IZ::elementOther3;
	lpMethod->nQueue[8]	 = CMGC4IZ::elementOther6;
	lpMethod->nQueue[9]	 = CMGC4IZ::elementFreeOne0;
	lpMethod->nQueue[10] = CMGC4IZ::elementOther7;
	lpMethod->nQueue[11] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[12] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[13] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[14] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[15] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[16] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[17] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[18] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[19] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[20] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[21] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[22] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[23] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[24] = CMGC4IZ::elementFooter;
	lpMethod->nQueueCount = 25;
		
	// STRUCTURE
	StringCchPrintfA(lpMethod->szTitle, CMGC4IZ::structureSizeA, "Test html");
	// METADATAS
	lpMethod->nCountForMetadata = 4;

	if(m_nResource == 0)
	{
		StringCchPrintfA(lpMethod->szNameOfMetadata[0], CMGC4IZ::metadataSizeA, "쐬");
		StringCchPrintfA(lpMethod->szContentOfMetadata[0], CMGC4IZ::metadataSizeA, "m.magic");
		StringCchPrintfA(lpMethod->szNameOfMetadata[1], CMGC4IZ::metadataSizeA, "BPP");
		StringCchPrintfA(lpMethod->szContentOfMetadata[1], CMGC4IZ::metadataSizeA, "24");
		StringCchPrintfA(lpMethod->szNameOfMetadata[2], CMGC4IZ::metadataSizeA, "GENERATOR");
		StringCchPrintfA(lpMethod->szContentOfMetadata[2], CMGC4IZ::metadataSizeA, "m.magic IZ dll");
		StringCchPrintfA(lpMethod->szNameOfMetadata[3], CMGC4IZ::metadataSizeA, "FORM");
		StringCchPrintfA(lpMethod->szContentOfMetadata[3], CMGC4IZ::metadataSizeA, "xx.1234-oo");
	}
	else
	{
		StringCchPrintfA(lpMethod->szNameOfMetadata[0], CMGC4IZ::metadataSizeA , "Author");
		StringCchPrintfA(lpMethod->szContentOfMetadata[0], CMGC4IZ::metadataSizeA, "m.magic");
		StringCchPrintfA(lpMethod->szNameOfMetadata[1], CMGC4IZ::metadataSizeA, "BPP");
		StringCchPrintfA(lpMethod->szContentOfMetadata[1], CMGC4IZ::metadataSizeA, "24");
		StringCchPrintfA(lpMethod->szNameOfMetadata[2], CMGC4IZ::metadataSizeA, "GENERATOR");
		StringCchPrintfA(lpMethod->szContentOfMetadata[2], CMGC4IZ::metadataSizeA, "m.magic IZ dll");
		StringCchPrintfA(lpMethod->szNameOfMetadata[3], CMGC4IZ::metadataSizeA, "FORM");
		StringCchPrintfA(lpMethod->szContentOfMetadata[3], CMGC4IZ::metadataSizeA, "xx.1234-oo");
	}

	// HEADER
	CTime time =  CTime::GetCurrentTime();
	
	StringCchPrintfA(lpMethod->szHeaderTitle, CMGC4IZ::headerSizeA, "&nbsp;%s", m_szFileName);
	StringCchPrintfA(	lpMethod->szDate, 
						CMGC4IZ::headerSizeB,
						"%s&nbsp;",
						time.Format("%#c").GetBuffer()	);

	// IMAGE
	if(bOutputImage)
	{
		// %drive%\x1\x.jpg
		StringCchPrintfA(lpMethod->szImagePathAndName, MAX_PATH, m_szThumbnailPathAndName);	
		// x.jpg
		StringCchPrintfA(lpMethod->szImageName, MAX_PATH, m_szThumbnailName);				
		if(!m_imgThumbnail.IsNull())
		{
			lpMethod->nImageWidth = m_imgThumbnail.GetWidth();
			lpMethod->nImageHeight = m_imgThumbnail.GetHeight();
		}
	}
	else
	{
		lpMethod->szImagePathAndName[0] = 0;
		lpMethod->szImageName[0] = 0;
		lpMethod->nImageWidth = 0;
		lpMethod->nImageHeight = 0;
	}

	// FIELD HEADER
	if(m_nResource == 0)
	{
		StringCchPrintfA(lpMethod->szFieldNames[0], CMGC4IZ::fieldSizeA, "");
		StringCchPrintfA(lpMethod->szFieldNames[1], CMGC4IZ::fieldSizeA, "^O");
		StringCchPrintfA(lpMethod->szFieldNames[2], CMGC4IZ::fieldSizeA, "O");
		StringCchPrintfA(lpMethod->szFieldNames[3], CMGC4IZ::fieldSizeA, "l");
	}
	else
	{
		StringCchPrintfA(lpMethod->szFieldNames[0], CMGC4IZ::fieldSizeA, "kind");
		StringCchPrintfA(lpMethod->szFieldNames[1], CMGC4IZ::fieldSizeA, "tag");
		StringCchPrintfA(lpMethod->szFieldNames[2], CMGC4IZ::fieldSizeA, "name");
		StringCchPrintfA(lpMethod->szFieldNames[3], CMGC4IZ::fieldSizeA, "values");
	}
	
	// FIELD
	StringCchPrintfA(lpMethod->szKinds[0], CMGC4IZ::fieldSizeA, "Tiff");
	StringCchPrintfA(lpMethod->szKinds[1], CMGC4IZ::fieldSizeA, "Exif");
	StringCchPrintfA(lpMethod->szKinds[2], CMGC4IZ::fieldSizeA, "GPS");
	StringCchPrintfA(lpMethod->szKinds[3], CMGC4IZ::fieldSizeA, "Interoperability");
	StringCchPrintfA(lpMethod->szKinds[4], CMGC4IZ::fieldSizeA, "Thumbnail");
	
	// OTHER
	if(m_nResource == 0)
	{
		StringCchPrintfA(lpMethod->szOthers[0], CMGC4IZ::otherSizeA, "0: %s", m_szPathAndName);
		StringCchPrintfA(lpMethod->szOthers[1], CMGC4IZ::otherSizeA, "1: 쐬 MR.x");
		StringCchPrintfA(lpMethod->szOthers[2], CMGC4IZ::otherSizeA, "2: ");
		StringCchPrintfA(lpMethod->szOthers[3], CMGC4IZ::otherSizeA, "3:<font color=""Red"">Fw肵</font>");
		StringCchPrintfA(lpMethod->szOthers[4], CMGC4IZ::otherSizeA, "4:");
		StringCchPrintfA(lpMethod->szOthers[5], CMGC4IZ::otherSizeA, "5:");
		StringCchPrintfA(lpMethod->szOthers[6], CMGC4IZ::otherSizeA, "");
		StringCchPrintfA(lpMethod->szOthers[7], CMGC4IZ::otherSizeA, "");
		StringCchPrintfA(lpMethod->szOthers[8], CMGC4IZ::otherSizeA, "");
		StringCchPrintfA(lpMethod->szOthers[9], CMGC4IZ::otherSizeA, "");
	}
	else
	{
		StringCchPrintfA(lpMethod->szOthers[0], CMGC4IZ::otherSizeA, "0: %s", m_szPathAndName);
		StringCchPrintfA(lpMethod->szOthers[1], CMGC4IZ::otherSizeA, "1: Author MR.x");
		StringCchPrintfA(lpMethod->szOthers[2], CMGC4IZ::otherSizeA, "2: ");
		StringCchPrintfA(lpMethod->szOthers[3], CMGC4IZ::otherSizeA, "3: <font color=""Red"">set color</font>");
		StringCchPrintfA(lpMethod->szOthers[4], CMGC4IZ::otherSizeA, "4:");
		StringCchPrintfA(lpMethod->szOthers[5], CMGC4IZ::otherSizeA, "5:");
		StringCchPrintfA(lpMethod->szOthers[6], CMGC4IZ::otherSizeA, "");
		StringCchPrintfA(lpMethod->szOthers[7], CMGC4IZ::otherSizeA, "");
		StringCchPrintfA(lpMethod->szOthers[8], CMGC4IZ::otherSizeA, "");
		StringCchPrintfA(lpMethod->szOthers[9], CMGC4IZ::otherSizeA, "");
	}
	
	// FREEONE
	StringCchPrintfA(	lpMethod->szFreeOnes[0],
						CMGC4IZ::freeOneSizeA,
						"\t<TR>\n"\
							"\t\t<TD COLSPAN=4 WIDTH=1000 HEIGHT=18 ALIGN=CENTER>\n"\
								"\t\t\tCopyright 20xx-20xx\n"\
								"\t\t\t&nbsp;\n"\
							"\t\t</TD>\n"\
						"\t</TR>"	);	
	StringCchPrintfA(	lpMethod->szFreeOnes[9],
						CMGC4IZ::freeOneSizeA,
						"\t<TR>\n"\
						"	\t\t<TD COLSPAN=4 WIDTH=1000 HEIGHT=18 ALIGN=LEFT BGCOLOR=""#FF9900"">&nbsp;</TD>\n"\
						"\t</TR>");
	StringCchPrintfA(lpMethod->szFreeOnes[2], CMGC4IZ::freeOneSizeA, "");
	StringCchPrintfA(lpMethod->szFreeOnes[3], CMGC4IZ::freeOneSizeA, "");
	StringCchPrintfA(lpMethod->szFreeOnes[4], CMGC4IZ::freeOneSizeA, "");
	StringCchPrintfA(lpMethod->szFreeOnes[5], CMGC4IZ::freeOneSizeA, "");

	// FOOTER HEADER
	StringCchPrintfA(lpMethod->szFooter, CMGC4IZ::footerSizeA, "");
	
	// \[Xt@Cł CMGC4IZ::optCodeUTF8 ̂ݎgp\
	nResult = m_lpIZ->Begin(	CMGC4IZ::cmdSaveFile | CMGC4IZ::optHtmlForm0 | CMGC4IZ::optCodeUTF8,
								lpMethod	);

	StringCchPrintf(szText, 512, _T("Error = %d"), nResult);
	AfxMessageBox(szText, MB_OK | MB_ICONINFORMATION);

	delete lpMethod;
}

void CTestIZDlg::OnFileHtmlForm1()
{
	//
	//// HTML t@Cւ̏ (MSO `)
	//
	INT		nResult = CMGC4IZ::failure;
	TCHAR	szText[512];
	TCHAR	szPath[MAX_PATH];
	CMGC4IZ::LPMETHOD_FOR_FORM1	lpMethod;
		

	// load form
	m_lpIZ->LoadHtmlForm(m_nResource == 0, CMGC4IZ::idrHtmlForm1);

	// path name for html
	if(!ShowDirectoryListBox(szPath, MAX_PATH))
		return;
	
	lpMethod = new CMGC4IZ::METHOD_FOR_FORM1;

	// TARGET iHTML o͐j
	StringCchPrintfA(lpMethod->szPath, MAX_PATH, CT2A(szPath));	// %drive%\x1
	StringCchPrintfA( lpMethod->szFileName,
					  MAX_PATH,
					  "%s.mso.%d.htm",
					  m_szFileName,
					  m_nResource		);	// x.htm Kgq́A.htm	

	// elements ̏o͏
	//
	//	elements ɏo͂lݒ肷Bɐݒ肵vfzO珇ɏo͂B
	//	vfɂ́ACMGC4IZ::elementImage/CMGC4IZ::elementFields/CMGC4IZ::elementFieldHeader/CMGC4IZ::elementOther
	//	/CMGC4IZ::elementFreeOne BOTHER ͔Cӂȕo͂łB
	//	CMGC4IZ::elementDontOutput == 0 ͏o͂ȂB
	//	̂𕡐o͂邱Ƃ\
	lpMethod->nQueue[0]  = CMGC4IZ::elementHeader;
	lpMethod->nQueue[1]	 = CMGC4IZ::elementOther0;
	lpMethod->nQueue[2]	 = CMGC4IZ::elementOther5;
	lpMethod->nQueue[3]	 = CMGC4IZ::elementFieldHeader;	
	lpMethod->nQueue[4]	 = CMGC4IZ::elementFields;
	lpMethod->nQueue[5]	 = CMGC4IZ::elementImage;
	lpMethod->nQueue[6]	 = CMGC4IZ::elementOther4;
	lpMethod->nQueue[7]	 = CMGC4IZ::elementOther3;
	lpMethod->nQueue[8]	 = CMGC4IZ::elementFreeOne0;
	lpMethod->nQueue[9]	 = CMGC4IZ::elementFooter;
	lpMethod->nQueue[10] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[11] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[12] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[13] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[14] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[15] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[16] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[17] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[18] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[19] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[20] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[21] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[22] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[23] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[24] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueue[25] = CMGC4IZ::elementDontOutput;
	lpMethod->nQueueCount = 10;
		
	// STRUCTURE
	StringCchPrintfA(lpMethod->szTitle, CMGC4IZ::structureSizeA, "&nbsp;Test html");
	// METADATAS 0
	lpMethod->nCountForMetadata0 = 2;

	StringCchPrintfA(lpMethod->szNameOfMetadata0[0], CMGC4IZ::metadataSizeA, "GENERATOR");
	StringCchPrintfA(lpMethod->szContentOfMetadata0[0], CMGC4IZ::metadataSizeA, "m.magic IZ dll");
	StringCchPrintfA(lpMethod->szNameOfMetadata0[1], CMGC4IZ::metadataSizeA, "FORM");
	StringCchPrintfA(lpMethod->szContentOfMetadata0[1], CMGC4IZ::metadataSizeA, "xx.1234-oo");

	// metadatas 1
	CTime time =  CTime::GetCurrentTime();
	lpMethod->nCountForMetadata1 = 4;

	StringCchPrintfA(lpMethod->szNameOfMetadata1[0], CMGC4IZ::metadataSizeA, "Author");
	StringCchPrintfA(lpMethod->szContentOfMetadata1[0], CMGC4IZ::metadataSizeA, "Mr.X");
	StringCchPrintfA(lpMethod->szNameOfMetadata1[1], CMGC4IZ::metadataSizeA, "LastAuthor");
	StringCchPrintfA(lpMethod->szContentOfMetadata1[1], CMGC4IZ::metadataSizeA, "Mr.X");
	StringCchPrintfA(lpMethod->szNameOfMetadata1[2], CMGC4IZ::metadataSizeA, "LastSaved");
	StringCchPrintfA(	lpMethod->szContentOfMetadata1[2], 
						CMGC4IZ::metadataSizeA, 
						CT2A( time.FormatGmt(_T("%Y-%m-%dT%H:%M:%SZ")) )	);
	StringCchPrintfA(lpMethod->szNameOfMetadata1[3], CMGC4IZ::metadataSizeA, "Category");
	StringCchPrintfA(lpMethod->szContentOfMetadata1[3], CMGC4IZ::metadataSizeA, "EXIF informations");

	// metadatas 2
	lpMethod->nCountForMetadata2 = 3;

	StringCchPrintfA(lpMethod->szNameOfMetadata2[0], CMGC4IZ::metadataSizeA, "FORM");
	StringCchPrintfA(lpMethod->szTypeOfMetadata2[0], CMGC4IZ::metadataSizeB, "string");
	StringCchPrintfA(lpMethod->szContentOfMetadata2[0], CMGC4IZ::metadataSizeA, "xx.1234-ms");

	StringCchPrintfA(lpMethod->szNameOfMetadata2[1], CMGC4IZ::metadataSizeA, "l");
	StringCchPrintfA(lpMethod->szTypeOfMetadata2[1], CMGC4IZ::metadataSizeB, "float");
	StringCchPrintfA(lpMethod->szContentOfMetadata2[1], CMGC4IZ::metadataSizeA, "1234");

	StringCchPrintfA(lpMethod->szNameOfMetadata2[2], CMGC4IZ::metadataSizeA, "t");
	StringCchPrintfA(lpMethod->szTypeOfMetadata2[2], CMGC4IZ::metadataSizeB, "dateTime.tz");
	StringCchPrintfA(	lpMethod->szContentOfMetadata2[2],
						CMGC4IZ::metadataSizeA,
						CT2A( time.FormatGmt("%Y-%m-%dT%H:%M:%SZ") )	);

	StringCchPrintfA(lpMethod->szNameOfMetadata2[3], CMGC4IZ::metadataSizeA, "L");
	StringCchPrintfA(lpMethod->szTypeOfMetadata2[3], CMGC4IZ::metadataSizeB, "boolean");
	StringCchPrintfA(lpMethod->szContentOfMetadata2[3], CMGC4IZ::metadataSizeA, "1");

	StringCchPrintfA(lpMethod->szNameOfMetadata2[4], CMGC4IZ::metadataSizeA, "");
	StringCchPrintfA(lpMethod->szTypeOfMetadata2[4], CMGC4IZ::metadataSizeB, "");
	StringCchPrintfA(lpMethod->szContentOfMetadata2[4], CMGC4IZ::metadataSizeA, "");

	StringCchPrintfA(lpMethod->szNameOfMetadata2[5], CMGC4IZ::metadataSizeA, "");
	StringCchPrintfA(lpMethod->szTypeOfMetadata2[5], CMGC4IZ::metadataSizeB, "");
	StringCchPrintfA(lpMethod->szContentOfMetadata2[5], CMGC4IZ::metadataSizeA, "");

	// HEADER
	StringCchPrintfA(lpMethod->szHeaderTitle, CMGC4IZ::headerSizeA, "&nbsp;%s", m_szFileName);
	StringCchPrintfA(lpMethod->szDate, CMGC4IZ::headerSizeB, "%s&nbsp;", time.Format("%#c"));

	// IMAGE
	StringCchPrintfA(lpMethod->szImagePathAndName, MAX_PATH, m_szThumbnailPathAndName);	// %drive%\x1\x.jpg
	StringCchPrintfA(lpMethod->szImageName, MAX_PATH, m_szThumbnailName);				// x.jpg

	if(!m_imgThumbnail.IsNull())
	{
		lpMethod->nImageWidth = m_imgThumbnail.GetWidth();
		lpMethod->nImageHeight = m_imgThumbnail.GetHeight();
	}
	
	// FIELD HEADER
	if(m_nResource == 0)
	{
		StringCchPrintfA(lpMethod->szFieldNames[0], CMGC4IZ::fieldSizeA, "&nbsp;");
		StringCchPrintfA(lpMethod->szFieldNames[1], CMGC4IZ::fieldSizeA, "^O");
		StringCchPrintfA(lpMethod->szFieldNames[2], CMGC4IZ::fieldSizeA, "O");
		StringCchPrintfA(lpMethod->szFieldNames[3], CMGC4IZ::fieldSizeA, "l");
	}
	else
	{
		StringCchPrintfA(lpMethod->szFieldNames[0], CMGC4IZ::fieldSizeA, "&nbsp;");
		StringCchPrintfA(lpMethod->szFieldNames[1], CMGC4IZ::fieldSizeA, "tag");
		StringCchPrintfA(lpMethod->szFieldNames[2], CMGC4IZ::fieldSizeA, "name");
		StringCchPrintfA(lpMethod->szFieldNames[3], CMGC4IZ::fieldSizeA, "values");
	}

	// FIELD
	StringCchPrintfA(lpMethod->szKinds[0], CMGC4IZ::fieldSizeA, "Tiff");
	StringCchPrintfA(lpMethod->szKinds[1], CMGC4IZ::fieldSizeA, "Exif");
	StringCchPrintfA(lpMethod->szKinds[2], CMGC4IZ::fieldSizeA, "GPS");
	StringCchPrintfA(lpMethod->szKinds[3], CMGC4IZ::fieldSizeA, "Interoperability");
	StringCchPrintfA(lpMethod->szKinds[4], CMGC4IZ::fieldSizeA, "Thumbnail");
	
	// OTHER
	StringCchPrintfA(lpMethod->szOthers[0], CMGC4IZ::otherSizeA, "0:\"&<>^~- \"");
	StringCchPrintfA(lpMethod->szOthers[1], CMGC4IZ::otherSizeA, "1: 쐬 MR.x");
	StringCchPrintfA(lpMethod->szOthers[2], CMGC4IZ::otherSizeA, "2: o͂Ȃ");
	StringCchPrintfA(lpMethod->szOthers[3], CMGC4IZ::otherSizeA, "3: <font color=""Red"">Fw肵</font>");
	StringCchPrintfA(lpMethod->szOthers[4], CMGC4IZ::otherSizeA, "4: %s", m_szPathAndName);
	StringCchPrintfA(	lpMethod->szOthers[5], 
						CMGC4IZ::otherSizeA,
						"5:&quot;&amp;&lt;&gt;&circ;&tilde;&zwnj;&ndash;&nbsp;&quot;" );
	StringCchPrintfA(lpMethod->szOthers[6], CMGC4IZ::otherSizeA, "");
	StringCchPrintfA(lpMethod->szOthers[7], CMGC4IZ::otherSizeA, "");
	StringCchPrintfA(lpMethod->szOthers[8], CMGC4IZ::otherSizeA, "");
	StringCchPrintfA(lpMethod->szOthers[9], CMGC4IZ::otherSizeA, "");

	// FREEONE
	StringCchPrintfA(	lpMethod->szFreeOnes[0],
						CMGC4IZ::freeOneSizeA,
						"\t<TR>\n"\
							"\t\t<TD COLSPAN=4 WIDTH=1000 HEIGHT=18 ALIGN=CENTER>\n"\
								"\t\t\t<br>\n"\
								"\t\t\tCopyright 20xx-20xx\n"\
								"\t\t\t<br>\n"\
								"\t\t\t&nbsp;\n"\
							"\t\t</TD>\n"\
						"\t</TR>"	);
	StringCchPrintfA(lpMethod->szFreeOnes[2], CMGC4IZ::freeOneSizeA, "");
	StringCchPrintfA(lpMethod->szFreeOnes[3], CMGC4IZ::freeOneSizeA, "");
	StringCchPrintfA(lpMethod->szFreeOnes[4], CMGC4IZ::freeOneSizeA, "");
	StringCchPrintfA(lpMethod->szFreeOnes[5], CMGC4IZ::freeOneSizeA, "");

	// FOOTER HEADER
	StringCchPrintfA(lpMethod->szFooter, CMGC4IZ::footerSizeA, "footer");

	// \[Xt@Cł CMGC4IZ::optCodeUTF8 ̂ݎgp\
	nResult = m_lpIZ->Begin(	CMGC4IZ::cmdSaveFile | CMGC4IZ::optHtmlForm1 | CMGC4IZ::optCodeUTF8,
								lpMethod	);

	StringCchPrintf(szText, 512, _T("Error = %d"), nResult);
	AfxMessageBox(szText, MB_OK | MB_ICONINFORMATION);

	delete lpMethod;
}

void CTestIZDlg::OnFileOpen()
{
	//
	//// t@C Exif ǂݏo܂
	//
	static const INT	nFunctions[3] = { CMGC4IZ::read, CMGC4IZ::readPlusOne, CMGC4IZ::cmdRead };
				 INT	nResult = CMGC4IZ::failure;
				 TCHAR	szText[512];

#if _DEBUG
	const	INT	nSwitch = 1;
#else
	const	INT	nSwitch = 1;
#endif
	

	if(ShowFileDialog() == IDOK)
	{
		// :߂ltB[hAُF߂l̐
		nResult = m_lpIZ->Begin(nFunctions[nSwitch], (CA2W)m_szPathAndName); 
	}

	if(nResult > 0) 
	{
		if(m_nResource == 2)
			MakeRawList();
		else
			MakeList();
		
		// Thumbnail;
		SaveThumbnail();

		m_txtFileName.SetWindowText(CA2T(m_szPathAndName));

		StringCchPrintf(szText, 512, _T("o͐ = %d"), nResult);
	}
	else
	{
		StringCchPrintf(szText, 512, _T("Error = %d"), nResult);
	}

	AfxMessageBox(szText, MB_OK | MB_ICONINFORMATION);
}

BOOL CTestIZDlg::ShowDirectoryListBox(LPTSTR lpszPathName, const int nSize)
{
	BOOL			bR = FALSE;
	BROWSEINFO		bi;
	LPITEMIDLIST	lpidl = NULL;
	TCHAR			szPathName[MAX_PATH];

	
	bi.hwndOwner		= this->m_hWnd;
	bi.lpfn				= NULL;
	bi.lParam			= NULL;	
	bi.lpszTitle		= _T("TestIZ");
	bi.pidlRoot			= NULL;
	bi.pszDisplayName	= NULL;
	bi.ulFlags			= BIF_RETURNONLYFSDIRS | BIF_BROWSEFORCOMPUTER | BIF_DONTGOBELOWDOMAIN;
				
	lpidl = SHBrowseForFolder(&bi);

	if(lpidl != NULL) 
	{ 
		bR = SHGetPathFromIDList(lpidl, szPathName);
		
		if(bR)
			StringCchPrintf(lpszPathName, nSize, szPathName);
	}

	return bR;
}

int CTestIZDlg::ShowFileDialog()
{
	//
	//// File Dialog
	//
	CFileDialog dlg(	TRUE, 
						NULL, 
						NULL, 
						OFN_FILEMUSTEXIST, 
						_T( "Jpeg ̧ (*.jpg;*.jpeg)|*.jpg;*.jpeg|")\
						_T(	"ޕt- ̧ (*.Tif;*.Tiff)|*.Tif;*.Tiff||") );

	INT_PTR nResult = dlg.DoModal();

	if(nResult == IDOK)
	{
		StringCchCopyA( m_szFileName, MAX_PATH, CT2A(dlg.GetFileName()) );
		StringCchCopyA( m_szPathAndName, MAX_PATH, CT2A(dlg.GetPathName()) );
	}

	return (int)nResult;
}

void CTestIZDlg::MakeList()
{
	static LPCTSTR	lpszKindIFD[5] = {	_T("Tiff  "), 
										_T("Exif  "), 
										_T("GPS   "),
										_T("Thumb.  "),
										_T("Inter.")	}; 

	if(m_List1.GetItemCount() != 0)
		m_List1.DeleteAllItems();
	
	//
	//// ǂݏoXgɒǉ
	//
	// K
	//		CMGC4IZ::TEXT_SIZE ́ACMGC4IZ::FIELD_STRINGS.lpszName, CMGC4IZ::FIELD_STRINGS.lpszValue ̃TCY
	//		őĺACMGC4IZ::lengthName, CMGC4IZ::lengthValue Ԃ񏬂ł
	CMGC4IZ::TEXT_SIZE	textSize = {	CMGC4IZ::lengthName - 32,
										CMGC4IZ::lengthValue,
										0	};
	INT nCount = m_lpIZ->Begin(CMGC4IZ::beginDown, &textSize);

	if(nCount <= 0)
		return;


	INT	nIndex;
	INT	nKind;
	INT	nResult;
	TCHAR szItem[4][CMGC4IZ::lengthValue];
	TCHAR szName[CMGC4IZ::lengthName];
	TCHAR szValues[CMGC4IZ::lengthValue];

	CMGC4IZ::FIELD_STRINGS fieldStrings;
	

	nIndex = 0;
	nResult = CMGC4IZ::failure;
		
	fieldStrings.lpszName = new CHAR[textSize.nName];
	fieldStrings.lpszValues = new CHAR[textSize.nValue];
						
	for(INT nI = 0; nI < nCount; nI++)
	{
		nResult = m_lpIZ->Begin(CMGC4IZ::getStrings, &fieldStrings);

		if(nResult < CMGC4IZ::success)
			break;

		switch(fieldStrings.dwKindIFD)
		{
		case CMGC4IZ::kindIfdTiff:
			nKind = 0;
			break;
		case CMGC4IZ::kindIfdExif:
			nKind = 1;
			break;
		case CMGC4IZ::kindIfdGps:
			nKind = 2;
			break;
		case CMGC4IZ::kindIfdThumbnail:
			nKind = 3;
			break;
		default:
			nKind = 4;
		}

		StringCchCopy(szName, CMGC4IZ::lengthName, CA2T(fieldStrings.lpszName));
		StringCchCopy(szValues, CMGC4IZ::lengthValue, CA2T(fieldStrings.lpszValues));

		StringCchPrintf(szItem[0], CMGC4IZ::lengthValue, _T("%s"),		lpszKindIFD[nKind]);
		StringCchPrintf(szItem[1], CMGC4IZ::lengthValue, _T("0x%04x"),	fieldStrings.nTag);
		StringCchPrintf(szItem[2], CMGC4IZ::lengthValue, _T("%s"), szName);
		StringCchPrintf(szItem[3], CMGC4IZ::lengthValue, _T("%s"), szValues);
		
		nIndex = m_List1.InsertItem(0, szItem[0]);

		for(INT nJ = 1; nJ < 4; nJ++)
		{
			m_List1.SetItemText(nIndex, nJ, szItem[nJ]);
		}
	}
		
	delete [] fieldStrings.lpszName;
	delete [] fieldStrings.lpszValues;	

	//m_lpIZ->Begin(CMGC4IZ::resetField, NULL);


	TCHAR szText[512];

	if(nResult < CMGC4IZ::success)
	{
		StringCchPrintf(szText, 512, _T("Error = %d"), nResult);
		AfxMessageBox(szText, MB_OK | MB_ICONINFORMATION);
	}
}

void CTestIZDlg::MakeRawList()
{
	static const INT nL[11] = { 0, 1, 1, 2, 4, 4, 0, 1, 0, 4, 4 };
	static LPCTSTR	 lpszEndian[2]  = { _T("Little endian"), _T("Big endian") };
	static LPCTSTR	 lpszFormat[11] = {	_T("0"), 
										_T("0x%lx,"), _T("%d,"), _T("%d,"), _T("%d,"), _T("%d/"), 
										_T("6"), 
										_T("0x%lx,"), 
										_T("8"),
										_T("%d,"), _T("%d/") };
	static LPCTSTR	 lpszType[11] = {	_T("0"), 
										_T("BYTE"), _T("ASCII"), _T("SHORT"), _T("LONG"), _T("RATIONAL"), 
										_T("6"), 
										_T("UNDEFINED"), 
										_T("8"),
										_T("SLONG"), _T("SRATIONAL") };
	if(m_List1.GetItemCount() != 0)
		m_List1.DeleteAllItems();
	
	//
	//// ǂݏoXgɒǉ
	//
	// K
	//		CMGC4IZ::TEXT_SIZE ́ACMGC4IZ::FIELD_STRINGS.lpszName, CMGC4IZ::FIELD_STRINGS.lpszValue ̃TCY
	//		őĺACMGC4IZ::lengthName, CMGC4IZ::lengthValue Ԃ񏬂ł
	CMGC4IZ::TEXT_SIZE textSize = {	0,
								0,
								CMGC4IZ::lengthValue	};
	INT nCount = m_lpIZ->Begin(CMGC4IZ::beginDown, &textSize);

	if(nCount <= 0)
		return;

	INT	nIndex;
	INT nN;
	INT	nResult;
	CMGC4IZ::FIELD_DATA	fieldData;
	TCHAR szItem[4][CMGC4IZ::lengthValue];
	TCHAR szTmp[32];
	ULONGLONG nD;

	nIndex = 0;
	nResult = CMGC4IZ::failure;

	
	for(INT nI = 0; nI < nCount; nI++)
	{
		nResult = m_lpIZ->Begin(CMGC4IZ::getData, &fieldData);

		if(nResult < CMGC4IZ::success)
			break;

		if(fieldData.nEndian == CMGC4IZ::tifBigEndian)
		{
			Permute(2, (BYTE*)&fieldData.nTag);
			Permute(2, (BYTE*)&fieldData.nType);
			Permute(4, (BYTE*)&fieldData.nCount);
		}

		StringCchPrintf(szItem[0], CMGC4IZ::lengthValue, _T("0x%04lx"), fieldData.nTag);
		StringCchPrintf(szItem[1], CMGC4IZ::lengthValue, _T("%s"), lpszType[fieldData.nType]);
		StringCchPrintf(szItem[2], CMGC4IZ::lengthValue, _T("%d"), fieldData.nCount);
		szItem[3][0] = 0;

		nN = 1;

		switch(fieldData.nType)
		{
		case CMGC4IZ::ifdTypeAscii:
			StringCchCat(szItem[3], CMGC4IZ::lengthValue, (LPCTSTR)fieldData.szValues);
			break;
		case CMGC4IZ::ifdTypeRational: 
		case CMGC4IZ::ifdTypeSrational:
			nN = 2;
		default:
			for(INT nJ = 0; nJ < fieldData.nCount * nN; nJ++)
			{
				nD = 0;
											
				CopyMemory(	&nD, 
							&fieldData.szValues[nJ * nL[fieldData.nType]],
							nL[fieldData.nType]	);

				if(fieldData.nEndian == CMGC4IZ::tifBigEndian)
					Permute(nL[fieldData.nType], (BYTE*)&nD);

				StringCchPrintf(szTmp, 32, lpszFormat[fieldData.nType], nD);

				if(StringCchCat(szItem[3], CMGC4IZ::lengthValue, szTmp) != S_OK)
					break;

				if(nJ % nN == 1)
					szItem[3][lstrlen(szItem[3]) - 1] = ',';
			}

			szItem[3][lstrlen(szItem[3]) - 1] = 0;
		}

		nIndex = m_List1.InsertItem(0, szItem[0]);

		for(INT nJ = 1; nJ < 4; nJ++)
		{
			m_List1.SetItemText(nIndex, nJ, szItem[nJ]);
		}

		m_txtEndian.SetWindowText(lpszEndian[fieldData.nEndian == CMGC4IZ::tifBigEndian]);
	}
	
	m_lpIZ->Begin(CMGC4IZ::resetField, NULL);
}

void CTestIZDlg::Permute(INT nLength, BYTE* lpNumber)
{
	//
	//// BIG ENDIAN  LITTLE ENDIAN ɕϊ
	//
    BYTE szTmp[8];
	INT	 nJ;

	nJ = nLength - 1;
	CopyMemory(szTmp, lpNumber, nLength);

	for(INT nI = 0; nI < nLength; nI++)
	{
		lpNumber[nI] = szTmp[nJ--];
	}
}

void CTestIZDlg::SaveThumbnail()
{
	//
	//// TlCt@C쐬
	//

	// CImage
	HBITMAP bmp = m_imgThumbnail;


	if(bmp != NULL)
	{
		m_imgThumbnail.ReleaseGDIPlus();
		m_imgThumbnail.Destroy();
	}

	// TlC
	INT	nResult[2] = { CMGC4IZ::failure, CMGC4IZ::failure };
	CMGC4IZ::THUMBNAIL_IMAGE	Thumbnail;
	CFile file;


	SecureZeroMemory(&Thumbnail, sizeof(CMGC4IZ::THUMBNAIL_IMAGE));
	m_szThumbnailName[0] = 0;
	m_szThumbnailPathAndName[0] = 0;

	// TCY擾
	nResult[0] = m_lpIZ->Begin(CMGC4IZ::getThumbnail, &Thumbnail);

	if(nResult[0] == CMGC4IZ::success) 
	{
		Thumbnail.lpszImage = new BYTE[Thumbnail.nSize];
		nResult[1] = m_lpIZ->Begin(CMGC4IZ::getThumbnail, &Thumbnail);

		if(nResult[1] == CMGC4IZ::success)
		{
			::GetCurrentDirectoryA(MAX_PATH, m_szThumbnailPathAndName);

			if(Thumbnail.nCompression == 6)
			{
				StringCchCopyA(m_szThumbnailName, MAX_PATH, "Thumbnail.jpg");
				StringCchCatA(m_szThumbnailPathAndName, MAX_PATH, "\\Thumbnail.jpg");
			}
			else
			{
				StringCchCopyA(m_szThumbnailName, MAX_PATH, "Thumbnail.tif");
				StringCchCatA(m_szThumbnailPathAndName, MAX_PATH, "\\Thumbnail.tif");
			}
			
			file.Open(CA2T(m_szThumbnailPathAndName), CFile::modeCreate | CFile::modeWrite);
			file.Write(Thumbnail.lpszImage, Thumbnail.nSize);
			file.Flush();
			file.Close();
			delete Thumbnail.lpszImage;

			// CImage
			HBITMAP bmp = m_imgThumbnail;

			if(bmp == NULL)
			{
				m_imgThumbnail.Load(CA2T(m_szThumbnailPathAndName));
				InvalidateRect(NULL);
			}
		}

		nResult[0] = nResult[1];
	}

	if(nResult[0] != CMGC4IZ::success)
	{
        TCHAR szText[64];
		StringCchPrintf(szText, 64, _T("Error = %d"), nResult[0]);
		AfxMessageBox(szText, MB_OK | MB_ICONINFORMATION);
	}
	else
	{
		m_lpIZ->Begin(CMGC4IZ::resetThumbnail, NULL);
	}
}
